#include "allegro.h"
#include <math.h>

#include <replay.h>
#include <main.h>
#include <jumper.h>
#include <hill.h>
#include <api.h>
#include <draw.h>
#include <ai.h>

char ai_key[255];

void ai_decisions(){
	for (int i=0;i<255;++i)
		ai_key[i]=0;
	switch (jumper.where_is){
		case READY:ai_key[KEY_RIGHT]=1;
			   break;
		case INRUN:
			   if (jumper.frict()>50)
				   ai_key[KEY_RIGHT]=1;
			   if (jumper.pxd<1000)
				   ai_key[KEY_DOWN]=1;
			   if (jumper.pxd>inrun[INRUN_N][0]-110)
				   ai_key[KEY_UP]=1;
			   break;
		case FLIGHT:
			   if (jumper.pyd>lagrange(jumper.pxd,hill)-150)
				   ai_key[KEY_LEFT]=1; else
			   if (jumper.cy[0]<jumper.cy[9]-20)
				   ai_key[KEY_RIGHT]=1;
			   break;
		case GROUND:
			   if (jumper.cx[0]>jumper.cx[5])
				   ai_key[KEY_LEFT]=1;
			
	}
}

int make_a_jump_ai(char *hill_f){
	double takeoff_s=0;
	char blok=0;
	int freeze;
	int cframes,sframes;
	struct frame current_f;
	int disp_cam_name=0;
	int zooming_cam=0; //only at the beginning.  don't move it if the user moves it!!!
	int result_p=-1;
	int notes[5]={0};
	int pdelay[5]={rand()%300, rand()%300, rand()%300, rand()%300, rand()%300};
	hill_file=hill_f;
	ZBUFFER *zbuf1;
	wind=rand()%60-30;
	side_wind=rand()%60-30;
	read_hill(hill_f);
	jumper.set();
	jumper.ready();
	start_rec();
	sframes=cframes=frames=0;
	jumper.pos_angle=-atan2(lagrange(5.0,inrun)-lagrange(0,inrun),5.0);
	iterations=0;	
	cam[5].sx=inrun[INRUN_N][0];
	cam[5].sy=inrun[INRUN_N][1]-50;
	cam[5].sz=-300;
	if (option(O_SHOW_AI)){
		zbuf1=create_zbuffer(screen_bufor);
		set_zbuffer(zbuf1);
		if (create_scene(1000,250)) {
			message("create scene: failed");
			exit(1);
		}
	}
	if (option(O_SHOW_AI)){
		zooming_cam=9;
		current_cam=1;
		ccam.angle_h=M_PI/4+M_PI/2;
		ccam.offsetx=inrun[INRUN_N][0];
		ccam.offsety=inrun[INRUN_N][1];
		ccam.offsetz=0;
		ccam.angle_v=-M_PI/8;
		ccam.dist=10500;
		fog_dist=14000;
	}
	while (!key[KEY_ESC] && !key[KEY_SPACE] && (option(O_SHOW_AI) || !jumper.block_keys)){
		while ((iterations || !option(O_SHOW_AI)) && !key[KEY_ESC]){
			ai_decisions();
			clear_frame(&current_f);
			++cframes;
			++disp_cam_name;
			if (cframes==BFPS){			//Measuring FPS				
				frames=sframes;
				cframes=sframes=0;
			}


			--iterations;
			if (jumper.where_is==FLIGHT)
				++flight_time;
/*			if (flight_time<10){
				freeze=iterations;
				message("%f",(double)wind/10);
				iterations=freeze;
			}*/
			if (!jumper.block_keys){

				if (ai_key[KEY_RIGHT]){
					current_f.key_right=1;
					if (jumper.where_is==READY) jumper.where_is=INRUN;
					jumper.anim(HEAD_FRONT,CHANGE/BFPS);
					if (jumper.where_is==FLIGHT && jumper.check_pos())
						jumper.anim(SKI_UP,-CHANGE/BFPS/5);
					if (jumper.where_is==FLIGHT && jumper.check_pos()){
						jumper.anim(SKI_WIDER,CHANGE/BFPS*20.0);
						jumper.anim(SKI_ANGLE,CHANGE/BFPS);
					}


				}
				if (ai_key[KEY_LEFT]) {
					current_f.key_left=1;
					jumper.anim(HEAD_FRONT,-CHANGE/BFPS);
					if (jumper.where_is==FLIGHT)
						jumper.anim(SKI_UP,CHANGE/BFPS/5);
					if (jumper.where_is==FLIGHT && jumper.check_pos()) {
						jumper.anim(SKI_WIDER,-CHANGE/BFPS*20.0);
						jumper.anim(SKI_ANGLE,-CHANGE/BFPS);
					}

				}
				if (ai_key[KEY_UP] || takeoff_s>0) {
					current_f.key_up=1;
					jumper.anim(KNEE_UP,takeoff_s>BFPS/10.0 ? CHANGE/BFPS*2 : CHANGE*10.0/BFPS);
					if (takeoff_s<BFPS/10.0) {
						if (jumper.where_is<=INRUN)
							jumper.anim(HEAD_FRONT,-CHANGE/BFPS/0.5);
						jumper.j_bonus+=F_TAKEOFF/BFPS;
					} else {
						if (jumper.where_is<=INRUN)
						jumper.takeoff();
					}
					++takeoff_s;
				}
				if (ai_key[KEY_DOWN]) {
					current_f.key_down=1;
					jumper.anim(KNEE_UP,-CHANGE/BFPS);
					if (jumper.where_is>INRUN)
						takeoff_s=-10000;
				}
			} else {
				if (result_p>-1){
					return result_p;
				}
				
			}
			if (option(O_SHOW_AI)){
				if (key[KEY_P] && !blok){
					freeze=iterations;
					while ((!blok || !key[KEY_P]) && !key[KEY_ESC] && !key[KEY_SPACE]){
						if (!key[KEY_P]) blok=1;
					}
					blok=1;
					iterations=freeze;
				}
				if (!key[KEY_P])
					blok=0;
//#ifdef DEBUG
				if (key[KEY_Q])
					fog_dist-=10;
				if (key[KEY_W])
					fog_dist+=10;
//#endif
				if (key[KEY_S]){
					char *rn;
					freeze=iterations;
					while (key[KEY_S]);
					rn=getstring("Enter file name to which replay will be saved:",".rpl");
					save_replay(rn,hill_f);
					iterations=freeze;
				}
				if (key[KEY_R] && jumper.block_keys){
					freeze=iterations;
					load_replay(0);
					iterations=freeze;
					return result_p;
				}
				if (key[KEY_J]){
					ccam.rotate(-0.01,0,0);
				}
				if (key[KEY_L]){
					ccam.rotate(0.01,0,0);
				}
				if (key[KEY_I]){
					ccam.rotate(0,-0.01,0);
				}
				if (key[KEY_K]){
					ccam.rotate(0,0.01,0);
				}
				if (key[KEY_Z])
					ccam.rotate(0,0,10);
				if (key[KEY_X])
					ccam.rotate(0,0,-10);
				for (int i=KEY_F1;i<=KEY_F6;++i){
					if (key[i]) { 
						current_cam=i-KEY_F1;
						disp_cam_name=0;
					}
				}
			}
			if (zooming_cam==0)
			jumper.update_pos();
			if (jumper.where_is>READY && option(O_SHOW_AI)){
				if (zooming_cam>0){
					zooming_cam=9;
					if (cam[1].dist>500) cam[1].dist-=50; else --zooming_cam;
					if (cam[1].angle_h>-M_PI/4+0.02)
						cam[1].angle_h-=M_PI/200; else --zooming_cam;
					if (cam[1].angle_h<-M_PI/4-0.02)
						cam[1].angle_h+=M_PI/2; else --zooming_cam;
					if (cam[1].angle_v>-M_PI/4+0.02)
						cam[1].angle_v-=M_PI/1000; else --zooming_cam;
					if (cam[1].angle_v<-M_PI/4-0.02)
						cam[1].angle_v+=M_PI/1000; else --zooming_cam;

					if (cam[1].offsetx>jumper.pxd+25) cam[1].offsetx-=50; else --zooming_cam;
					if (cam[1].offsetx<jumper.pxd-25) cam[1].offsetx+=50; else --zooming_cam;
					if (cam[1].offsety>jumper.pyd+25) cam[1].offsety-=50; else --zooming_cam;
					if (cam[1].offsety<jumper.pyd-25) cam[1].offsety+=50; else --zooming_cam;
					if (cam[1].offsetx<jumper.pxd+100 && cam[1].offsetx>jumper.pxd-100)
						cam[1].offsetx=jumper.pxd;
					if (cam[1].offsety<jumper.pyd+100 && cam[1].offsety>jumper.pyd-100)
						cam[1].offsety=jumper.pyd;

				} else {
					fog_dist=5000;
					if (ccam.type==FPP)
					ccam.move(jumper.pxd+jumper.cx[0], jumper.pyd+jumper.cy[0]-10, jumper.pzd+jumper.cz[0]);
					else
					ccam.move(jumper.pxd, jumper.pyd, jumper.pzd);
				}
			}

			if (!jumper.block_keys){
				current_f.wind=wind;
				current_f.s_wind=side_wind;
				rand_wind();
				add_frame(current_f);
			}
			if (jumper.block_keys && notes[0]==0){
				int nmin=40,nmax=0, w1,w2;
				get_notes(notes);
				for (int i=0;i<5;++i){
					if (notes[i]>nmax) { nmax=notes[i]; w2=i;}
				}
				for (int i=0;i<5;++i){
					if (notes[i]<nmin && i!=w2) { nmin=notes[i]; w1=i;}
				}
				for (int i=0;i<5;++i)
					if (i!=w1 && i!=w2)
						result_p+=notes[i]*5;
				result_p+=(int)((((floor(result/ZOOM*2)/2)-(double)k_dist)*factor(k_dist))+600.0);
				if (k_dist>=180) result_p+=600;					
			}
			if (jumper.block_keys){
				for (int i=0;i<5;++i)
					if (pdelay[i]) --pdelay[i];
			}


		}
		if (option(O_SHOW_AI)){
			++sframes;
			jumper.rotate(jumper.pos_angle);
			ccam.activate();
			jumper.rotate(-jumper.pos_angle);
			blit(screen_bufor,screen,0,0,0,0,SCREEN_W,SCREEN_H);
			background(&screen_bufor);
			clear_scene(screen_bufor);
			clear_zbuffer(zbuf1,0.);
			hill_floor(50);
			render_scene();
			clear_scene(screen_bufor);
			clear_zbuffer(zbuf1,0.);
			inrun_floor(20);
			if (ccam.angle_h>=-M_PI/2 && ccam.angle_h<=M_PI/2){
				if (ccam.sx>=inrun[INRUN_N][0])
					hill_right(20);
				inrun_right(20);
			}else {
				if (ccam.sx>=inrun[INRUN_N][0])
					hill_left(20);
				inrun_left(20);
			}
			if (ccam.type!=FPP){
				jumper.draw_shadow();
				hill_bench();
				jumper.draw_main();
			}
			render_scene();
			if (ccam.angle_h>=-M_PI/2 && ccam.angle_h<=M_PI/2){
				if (ccam.sx>=inrun[INRUN_N][0])
					hill_left(20);
				inrun_left(20);
			}else {
				if (ccam.sx>=inrun[INRUN_N][0])
					hill_right(20);
				inrun_right(20);
			}
			hill_ceil(20);
			jumper.draw_small(20+128/3,20+96*1/3,0.3);
			hill_small(20,20,128,96,(int)jumper.pxd-SCREEN_W*1/3,(int)jumper.pxd+SCREEN_W*2/3,
						(int)jumper.pyd-SCREEN_H*1/3,(int)jumper.pyd+SCREEN_H*2/3);
#ifdef DEBUG
			jumper.params();
#endif
			if (disp_cam_name<300)
				textprintf_centre(screen_bufor,font,SCREEN_W/2,20,H_TEXT_COLOR,"%s",ccam.name);
		}
	}
	if (option(O_SHOW_AI)){
		destroy_scene();
		destroy_zbuffer(zbuf1);
	}

}

	
