#include "allegro.h"
#include <stdio.h>
#include <math.h>
#include <string.h>

#include "api.h"
#include "main.h"
#include "jumper.h"
#include "hill.h"
#include "draw.h"
BITMAP *tmpbmp;

void message(char *c, ...){
	va_list args;
	char buf[200];
	int length;
	clear_keybuf();
	va_start(args,c);
	vsprintf(buf,c,args);
	length=text_length(font,buf)+50;
	tmpbmp=create_bitmap(length,40);
	blit(screen,tmpbmp,(SCREEN_W-length)/2,(SCREEN_H-40)/2,0,0,length,40);
	drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
	set_trans_blender(0,0,0,128);	
	rectfill(screen,(SCREEN_W-length)/2,(SCREEN_H-40)/2,(SCREEN_W+length)/2,(SCREEN_H+40)/2,-1);
	textprintf_centre(screen,font,SCREEN_W/2,SCREEN_H/2-5,0,"%s", buf);
	readkey();
	drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
	blit(tmpbmp,screen,0,0,(SCREEN_W-length)/2,(SCREEN_H-40)/2,length,40);
	clear_keybuf();
}
char *getstring(char *c, char *suf, ...){
	va_list args;
	char buf[200];
	int length;
	const int max_length=400;
	int char_n=0;
	char *in=new char[255];
	int input;
	clear_keybuf();
	memset(in,0,200*sizeof(char));
	va_start(args,suf);
	vsprintf(buf,c,args);
	length=text_length(font,buf)+50;
	tmpbmp=create_bitmap(max_length+1,61);
	blit(screen,tmpbmp,(SCREEN_W-max_length)/2,SCREEN_H/2-20,0,0,max_length+1,61);
	while (1){
		drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
		set_trans_blender(0,0,0,128);	
		blit(tmpbmp,screen_bufor,0,0,(SCREEN_W-max_length)/2,(SCREEN_H-40)/2,max_length+1,61);

		rectfill(screen_bufor,(SCREEN_W-length)/2,SCREEN_H/2-20,(SCREEN_W-length)/2+length,(SCREEN_H+80)/2,-1);
		textprintf_centre(screen_bufor,font,SCREEN_W/2,SCREEN_H/2-5,0,"%s", buf);
		textprintf_centre(screen_bufor,font,SCREEN_W/2,SCREEN_H/2+15,0,"%s%s",in,suf);
		blit(screen_bufor,screen,0,0,0,0,SCREEN_W,SCREEN_H);

		input=readkey();
		if (( input >> 8)==KEY_BACKSPACE && char_n>0)
			in[--char_n]=0; 
		else if (( input >> 8)==KEY_ENTER)
			break;	
		else if (((input & 0xff)>=' ' && (input & 0xff)<='z')) in[char_n++]=(input & 0xff); 
		drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
		if (text_length(font,in)+50>length) length=text_length(font,in)+50;


	}
	drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
	blit(tmpbmp,screen,0,0,(SCREEN_W-length)/2,(SCREEN_H-40)/2,length+1,61);
	clear_keybuf();
	sprintf(&in[char_n],"%s",suf);
	return in;
}
int get_choice(int l, char *header, char **choices){
	int choice=0;
	int i;
	int menu_width=450;
	int menu_height=l*10+80;
	int menu_x=SCREEN_W/2-150;
	int menu_y=SCREEN_H/2-menu_height/2;
	char key_down=1;
	char key_up=1;
	char key_esc=1;
	char key_enter=1;
	PALETTE pal;
	BITMAP *logo=load_bitmap(DATADIR"menu.pcx",pal);

	clear_to_color(screen_bufor,0);
	while ((!key[KEY_ESC] || key_esc) && (!key[KEY_ENTER] || key_enter)){
		if (!key[KEY_ESC])
			key_esc=0;
		if (!key[KEY_ENTER])
			key_enter=0;
		if (key[KEY_DOWN] && !key_down && choice<l-1){
				++choice;
				key_down=1;
		}
		if (!key[KEY_DOWN]) key_down=0;
		if (key[KEY_UP] && !key_up && choice>0){
				--choice;
				key_up=1;
		}
		if (!key[KEY_UP]) key_up=0;
		blit(logo,screen_bufor,0,0,0,0,640,480);

		drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
		set_trans_blender(0,0,0,128);	
		rectfill(screen_bufor,
			menu_x+SHADE_SHIFT,
			menu_y+SHADE_SHIFT,
			menu_x+menu_width+SHADE_SHIFT,
			menu_y+menu_height+SHADE_SHIFT,
			0);

		rectfill(screen_bufor,
			menu_x,
			menu_y,
			menu_x+menu_width,
			menu_y+menu_height,
			MENU_COLOR);
		textprintf(screen_bufor,font,menu_x+5,menu_y+5,MENU_TEXT_COLOR,"%s",header);
		hline(screen_bufor,menu_x+5,menu_y+15,menu_x+menu_width-5,MENU_TEXT_COLOR);
		for (i=0;i<l;++i){
			if (i==choice) 
				rectfill(screen_bufor,menu_x+5,menu_y+25+10*i-2,
						menu_x+menu_width-5,
						menu_y+25+10*i+8,MENU_HIGH_COLOR);
			textprintf(screen_bufor,font,
			menu_x+5,
			menu_y+25+i*10,MENU_TEXT_COLOR,
			"%s",choices[i]);
			text_mode(-1);
		}
		drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
		blit(screen_bufor,screen,0,0,0,0,SCREEN_W,SCREEN_H);
	}
	drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
	if (key[KEY_ESC])
		return l-1;
	if (key[KEY_ENTER])
		return choice;
	return 0;
}
int color_picker(int cdefault){
	int choice=cdefault;
	int menu_width=300;
	int menu_height=200;
	int menu_x=SCREEN_W/2-150;
	int menu_y=SCREEN_H/2-menu_height/2;
	char key_down=1;
	char key_up=1;
	char key_esc=1;
	char key_enter=1;
	ZBUFFER *zbuf1=create_zbuffer(screen_bufor);
	BITMAP *logo=load_bitmap(DATADIR"menu.pcx",NULL);
	jumper.set();
//	jumper.ready();
	jumper.pxd=jumper.pyd=jumper.pzd=0;
	jumper.pos_angle=0;
	current_cam=1;
//	ccam.rotate(-M_PI/4,0,-210);
/*	ccam.angle_h=-M_PI/4;
	ccam.angle_v=-M_PI/4;
	ccam.dist=390;
	ccam.move(90,0,0);*/
	ccam.place(25,0,0,-M_PI/4,-M_PI/4,300);
	ccam.activate();
	if (create_scene(1000,250)){
		message("create scene: failed");
		exit(1);
	}
	set_zbuffer(zbuf1);
	clear_to_color(screen_bufor,0);
	while ((!key[KEY_ESC] || key_esc) && (!key[KEY_ENTER] || key_enter)){
		if (!key[KEY_ESC])
			key_esc=0;
		if (!key[KEY_ENTER])
			key_enter=0;
		if (key[KEY_DOWN] && !key_down){
				++choice;
		//		key_down=1;
		}
		if (!key[KEY_DOWN]) key_down=0;
		if (key[KEY_UP] && !key_up && choice>0){
				--choice;
		//		key_up=1;
		}
		if (!key[KEY_UP]) key_up=0;
//		if (key[KEY_LEFT]) pzd+=1;
//		if (key[KEY_RIGHT]) pzd-=1;
		blit(logo,screen_bufor,0,0,0,0,640,480);

		drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
		set_trans_blender(0,0,0,128);	
		rectfill(screen_bufor,
			menu_x+SHADE_SHIFT,
			menu_y+SHADE_SHIFT,
			menu_x+menu_width+SHADE_SHIFT,
			menu_y+menu_height+SHADE_SHIFT,
			0);

		rectfill(screen_bufor,
			menu_x,
			menu_y,
			menu_x+menu_width,
			menu_y+menu_height,
			MENU_COLOR);
		textprintf(screen_bufor,font,menu_x+5,menu_y+5,MENU_TEXT_COLOR,"color set: %d",choice);
		drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
		jumper.scolor=choice;
		clear_scene(screen_bufor);
		clear_zbuffer(zbuf1,0.);
		jumper.draw_main();
		render_scene();
		blit(screen_bufor,screen,0,0,0,0,SCREEN_W,SCREEN_H);
	}
	ccam.rotate(M_PI/4,0,210);
//	ccam.move(90,0,0);
	if (key[KEY_ESC])
		return cdefault;
	if (key[KEY_ENTER])
		return choice;
	return 0;

}
void show_text(int l, char *header, char **choices, bool wait){
	int i;
	int menu_width=450;
	int menu_height=l*10+80;
	int menu_x=SCREEN_W/2-150;
	int menu_y=SCREEN_H/2-menu_height/2;
	char key_esc=1;
	char key_enter=1;
	char key_space=1;
	PALETTE pal;
	BITMAP *logo=load_bitmap(DATADIR"menu.pcx",pal);

	clear_to_color(screen_bufor,0);
	while ((!key[KEY_ESC] || key_esc) && (!key[KEY_ENTER] || key_enter) && (!key[KEY_SPACE] || key_space)){
		if (!key[KEY_ESC])
			key_esc=0;
		if (!key[KEY_ENTER])
			key_enter=0;
		if (!key[KEY_SPACE])
			key_space=0;
		blit(logo,screen_bufor,0,0,0,0,640,480);

		drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
		set_trans_blender(0,0,0,128);	
		rectfill(screen_bufor,
			menu_x+SHADE_SHIFT,
			menu_y+SHADE_SHIFT,
			menu_x+menu_width+SHADE_SHIFT,
			menu_y+menu_height+SHADE_SHIFT,
			0);

		rectfill(screen_bufor,
			menu_x,
			menu_y,
			menu_x+menu_width,
			menu_y+menu_height,
			MENU_COLOR);
		textprintf(screen_bufor,font,menu_x+5,menu_y+5,MENU_TEXT_COLOR,"%s",header);
		hline(screen_bufor,menu_x+5,menu_y+15,menu_x+menu_width-5,MENU_TEXT_COLOR);

		for (i=0;i<l;++i){
			textprintf(screen_bufor,font,
			menu_x+5,
			menu_y+25+i*10,MENU_TEXT_COLOR,
			"%s",choices[i]);
			text_mode(-1);
		}
		drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
		blit(screen_bufor,screen,0,0,0,0,SCREEN_W,SCREEN_H);
		if (!wait) return;
	}
}
void show_credits(int l, char *header, char **choices){
	
	PALETTE pal;
	BITMAP *logo=load_bitmap(DATADIR"menu.pcx",pal);
	BITMAP *alleg=load_bitmap(DATADIR"allegro.pcx",pal);
	
	int i;
	int menu_width=450;
	int menu_height=l*10+80+alleg->h;
	int menu_x=SCREEN_W/2-150;
	int menu_y=SCREEN_H/2-menu_height/2;
	char key_esc=1;
	char key_enter=1;
	
	clear_to_color(screen_bufor,0);
	while ((!key[KEY_ESC] || key_esc) && (!key[KEY_ENTER] || key_enter)){
		if (!key[KEY_ESC])
			key_esc=0;
		if (!key[KEY_ENTER])
			key_enter=0;
		blit(logo,screen_bufor,0,0,0,0,640,480);

		drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
		set_trans_blender(0,0,0,128);	
		rectfill(screen_bufor,
			menu_x+SHADE_SHIFT,
			menu_y+SHADE_SHIFT,
			menu_x+menu_width+SHADE_SHIFT,
			menu_y+menu_height+SHADE_SHIFT,
			0);

		rectfill(screen_bufor,
			menu_x,
			menu_y,
			menu_x+menu_width,
			menu_y+menu_height,
			MENU_COLOR);
		textprintf(screen_bufor,font,menu_x+5,menu_y+5,MENU_TEXT_COLOR,"%s",header);
		hline(screen_bufor,menu_x+5,menu_y+15,menu_x+menu_width-5,MENU_TEXT_COLOR);

		for (i=0;i<l;++i){
			textprintf(screen_bufor,font,
			menu_x+5,
			menu_y+25+i*10,MENU_TEXT_COLOR,
			"%s",choices[i]);
			text_mode(-1);
		}
		drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
		blit(alleg,screen_bufor,0,0,menu_x+menu_width/2-alleg->w/2,menu_y+menu_height-alleg->h-10,alleg->w,alleg->h);
		blit(screen_bufor,screen,0,0,0,0,SCREEN_W,SCREEN_H);
	}
}
menu_t::menu_t(char *c,...){
	va_list args;
	header=new char[255];
	va_start(args,c);
	vsprintf(header,c,args);
	n=0;
	last_choice=0;
	va_end(args);
}
menu_t::~menu_t(){
	delete header;
	for (int i=0;i<n;++i)
		delete items[i];
}
int menu_t::add_item(char *c,...){
	va_list args;
	char buf[200];
	va_start(args,c);
	vsprintf(buf,c,args);
	items[n]=new char[strlen(buf)+1];
	strcpy(items[n],buf);
	va_end(args);
	return ++n;
}
void menu_t::change_item(int i, char *c,...){
	va_list args;
	char buf[255];
	va_start(args,c);
	vsprintf(buf,c,args);
	delete items[i];
	items[i]=new char[strlen(buf)+1];
	strcpy(items[i],buf);
	va_end(args);	
}
void menu_t::delete_item(int i){
	delete items[i];
	for (int j=i;j<n-1;++j)
		items[j]=items[j+1];
	--n;
}
int menu_t::get_choice(){
	int choice=last_choice;
	int i;
	int menu_width=450;
	int menu_height=n*10+80;
	int menu_x=SCREEN_W/2-150;
	int menu_y=SCREEN_H/2-menu_height/2;
	char key_down=1;
	char key_up=1;
	char key_esc=1;
	char key_enter=1;
	PALETTE pal;
	BITMAP *logo=load_bitmap(DATADIR"menu.pcx",pal);

	clear_to_color(screen_bufor,0);
	while ((!key[KEY_ESC] || key_esc) && (!key[KEY_ENTER] || key_enter)){
		if (!key[KEY_ESC])
			key_esc=0;
		if (!key[KEY_ENTER])
			key_enter=0;
		if (key[KEY_DOWN] && !key_down && choice<n-1){
				++choice;
				key_down=1;
		}
		if (!key[KEY_DOWN]) key_down=0;
		if (key[KEY_UP] && !key_up && choice>0){
				--choice;
				key_up=1;
		}
		if (!key[KEY_UP]) key_up=0;
		blit(logo,screen_bufor,0,0,0,0,640,480);

		drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
		set_trans_blender(0,0,0,96);	
		rectfill(screen_bufor,
			menu_x+SHADE_SHIFT,
			menu_y+SHADE_SHIFT,
			menu_x+menu_width+SHADE_SHIFT,
			menu_y+menu_height+SHADE_SHIFT,
			0);
		set_trans_blender(0,0,0,128);
		rectfill(screen_bufor,
			menu_x,
			menu_y,
			menu_x+menu_width,
			menu_y+menu_height,
			MENU_COLOR);
		textprintf(screen_bufor,font,menu_x+5,menu_y+5,MENU_TEXT_COLOR,"%s",header);
		hline(screen_bufor,menu_x+5,menu_y+15,menu_x+menu_width-5,MENU_TEXT_COLOR);
		for (i=0;i<n;++i){
			if (i==choice) 
				rectfill(screen_bufor,menu_x+5,menu_y+25+10*i-2,
						menu_x+menu_width-5,
						menu_y+25+10*i+8,MENU_HIGH_COLOR);
			textprintf(screen_bufor,font,
			menu_x+5,
			menu_y+25+i*10,MENU_TEXT_COLOR,
			"%s",items[i]);
			text_mode(-1);
		}
		drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
		blit(screen_bufor,screen,0,0,0,0,SCREEN_W,SCREEN_H);
	}
	drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
	if (key[KEY_ESC]){
		last_choice=n-1;
		return n-1;
	}
	if (key[KEY_ENTER]){
		last_choice=choice;
		return choice;
	}
	return 0;
}


