#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <dirent.h>
#include <ctype.h>
#include "allegro.h"
#include <algorithm>

#include "cup.h"
#include "api.h"
#include "main.h"
#include "jumper.h"
#include "draw.h"
#include "ai.h"

using namespace std;

#define DD printf("%d\n", __LINE__);

enum system { KO, standard };
enum { GPOINTS, TPOINTS } sort_type;

void save_competitors();
void jumpers_menu();
void cup_start(char *);
char * read_cup_name(char *);
void add_item(char **, char *, int);
void destroy(char **, int);
void display_points(char *, bool, bool, bool, bool, bool wait=true);
void quicksort(int *, int *, int , int);
void add_cup_points();


int cup_points[30]={100,80,60,50,45,40,36,32,29,26,24,22,20,18,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1};


char* control_names[]={"human","AI bad jumper","AI good jumper","AI nation's hero"};
char* short_c_names[]={"human","ai0","ai1","ai2"};
int control_n=4;

void load_competitors();
void load_cup(char *);

static struct contestant * jumpers;
static int numberofcomp; /* number of competitors*/
static char ** hills;/*files with hills names*/
static enum system * syst;/*in which system competition is provided*/
static int numberofhills; /* number of hills*/

char *jumper_name;


char *files[255];
static int file_n;

bool operator < (contestant a, contestant b){
	switch (sort_type){
		case GPOINTS:if (a.gpoints<b.gpoints) return true; else return false;
				     break;
		case TPOINTS:if (a.tpoints<b.tpoints) return true; else return false;
				     break;
	}
}

void add_cfile(const char *filename, int atrib, int param){
	files[file_n]=new char[255];
	strcpy(files[file_n++],get_filename(filename));
//	return 0;
}

void cup_menu()
{
	int i=0, choice;
	menu_t cmenu=menu_t("Choose competition");
	char cup_name[255];
	file_n=0;
	for_each_file(DATADIR"*.cup",FA_DIREC | FA_RDONLY,add_cfile,0);
	for (int i=0;i<file_n;++i)
		cmenu.add_item(read_cup_name(files[i]));
	cmenu.add_item("Back");
	while ((choice=cmenu.get_choice())!=file_n) {
    		int cup_choice;
		strcpy(cup_name,read_cup_name(files[choice]));
		menu_t ccmenu=menu_t(cup_name);
		strcpy(cup_name,read_cup_name(files[choice]));
		ccmenu.add_item("Start competition");
		ccmenu.add_item("Set competitors");
		ccmenu.add_item("Back");
		while ((cup_choice=ccmenu.get_choice())!=2) {
			switch (cup_choice) {
				case 0:
					cup_start(files[choice]);
					break;
				case 1:
					jumpers_menu();
					break;
			}
	}
//	message("1");
//        destroy(cup_choices, j);
//	message("1");
    }
  //  	message("1");
//	destroy(choices, i);
//	message("1");
    destroy(files, i-1);
}

void cup_start(char * fname){
	int i;
	load_competitors();
	load_cup(fname);
	for (int i=0;i<numberofcomp;++i)
		jumpers[i].gpoints=0;
	game_type=COMPETITION;
	for (i=0;i<numberofhills;++i) {
    		char buf[255];
		char hill_name[255];
		char fullpath[255];
		for (int k=0;k<numberofcomp;++k){
			jumpers[k].dist1=jumpers[k].dist2=-1;
			jumpers[k].tpoints=-1000;
		}
		sprintf(fullpath,"%s%s",DATADIR,hills[i]);
		FILE *tmpfile=fopen(fullpath,"r");
		if (!tmpfile){
			message("error : file not found : %s",fullpath);
		}
		fscanf(tmpfile,"%s",hill_name);
		fclose(tmpfile);
		if (i>0) {
			sort_type=GPOINTS;
			sort(jumpers,jumpers+numberofcomp);
		}
        	for (int j=0;j<numberofcomp;++j){
			if (jumpers[j].cont == human) {
	            		jumper.name = jumpers[j].name;
				jumper.scolor=jumpers[j].color;
	        	    	jumpers[j].tpoints=make_a_jump(hills[i]);
				jumpers[j].dist1=(int)(result/ZOOM*2);
        	        	if (key[KEY_ESC]) return;
	                	jumper.name = NULL;
			} else { 
				jumper.name=jumpers[j].name;
				jumper.scolor=jumpers[j].color;
				jumpers[j].tpoints=make_a_jump_ai(hills[i]);
				jumpers[j].dist1=(int)(result/ZOOM*2);
				if (key[KEY_ESC]) return;
				jumper.name = NULL;
			}
			sprintf(buf,"Standings at %s during 1st round:",hill_name);
			display_points(buf,true,true,false,false,false);
		}
		sprintf(buf,"Standings at %s after 1st round:",hill_name);
		display_points(buf,true,true,false,false);
		sort_type=TPOINTS;
		sort(jumpers,jumpers+numberofcomp);
		for (int j=0;j<numberofcomp;++j){
			if (jumpers[j].cont == human) {
	            		jumper.name = jumpers[j].name;
				jumper.scolor=jumpers[j].color;
				jumpers[j].tpoints+=make_a_jump(hills[i]);
				jumpers[j].dist2=(int)(result/ZOOM*2);
        	        	if (key[KEY_ESC]) return;
	                	jumper.name = NULL;
			} else {
				jumper.name=jumpers[j].name;
				jumper.scolor=jumpers[j].color;
				jumpers[j].tpoints+=make_a_jump_ai(hills[i]);
				jumpers[j].dist2=(int)(result/ZOOM*2);
				if (key[KEY_ESC]) return;
				jumper.name = NULL;
			}
			sprintf(buf,"Standings at %s during 2nd round:",hill_name);
			display_points(buf,true,true,true,false,false);
		}
		sprintf(buf,"Standings at %s after 2nd round:",hill_name);
		display_points(buf, true,true,true,false);
		add_cup_points();
		sprintf(buf,"Standings after %d of %d competitions", i+1, numberofhills);
		display_points(buf, false,false,false,true);
		if (key[KEY_ESC]) return;
	}
	delete jumpers;
}
void add_cup_points(){
	sort(jumpers,jumpers+numberofcomp);
	for (int i=0;i<numberofcomp;++i)
		if (i<30)
			jumpers[i].gpoints+=cup_points[numberofcomp-i-1];
}

char * read_cup_name(char * fname)
{
	size_t len;
	char * tmp = new char[255];
	char fullpath[100];
	FILE * f;
	sprintf(fullpath,"%s%s",DATADIR,fname);
	f= fopen(fullpath, "r");
    if (f == NULL) {
        message("cannot load cup: %s",fname);
        exit(1);
    }
    fgets(tmp, 255, f);
    fclose(f);
    return tmp;
}

void add_item(char **array, char *item, int pos)
{
	array[pos]=new char[strlen(item)+1];//malloc((strlen(item)+1)*sizeof(char));
    strcpy(array[pos], item);
}

void destroy(char ** ptr, int n)
{
	int i;
	for (i=0;i<n;++i) delete ptr[i];
//    delete ptr;
}

void quicksort(int *a, int *p, int l, int r)
{
	int d=l, u=r, val = p[a[(l+r)/2]];
    while (d<u) {
		while (p[a[d]]>val) ++d;
        while (p[a[u]]<val) --u;
        if (d<u) { int t=a[d]; a[d]=a[u]; a[u]=t; ++d; --u; }
    }
    if (l<u) quicksort(a, p, l, u);
    if (u+1<r) quicksort(a, p, u+1, r);
}

void display_points(char *header, bool tpoints, bool dist1, bool dist2, bool gpoints, bool wait){
	char *text_field[100];
	contestant *jumpers_tmp=new contestant[numberofcomp];
	int i;
	for (i=0;i<numberofcomp;++i) {
		jumpers_tmp[i]=jumpers[i];
		text_field[i]=new char[255];
		for (int j=0;j<200;++j)
			text_field[i][j]=' ';
		text_field[i][200]='\0';
	}
	if (gpoints) sort_type=GPOINTS; else sort_type=TPOINTS;
	sort(jumpers_tmp,jumpers_tmp+numberofcomp);
	for (int j=0;j<numberofcomp;++j){
		i=numberofcomp-j-1;
		sprintf(text_field[j],"%-40s",jumpers_tmp[i].name);
		if (dist1 && jumpers_tmp[i].dist1>-1 && !gpoints)
		sprintf(&text_field[j][20],"%.1lf m %-20s",(double)(jumpers_tmp[i].dist1)/2.0,"");
		if (dist2 && jumpers_tmp[i].dist2>-1 && !gpoints)
		sprintf(&text_field[j][30],"%.1lf m %-20s",(double)(jumpers_tmp[i].dist2)/2.0,"");
		if (!dist1 && !dist2)
			sprintf(&text_field[j][40],"%d pts",jumpers_tmp[i].gpoints); else
		if (jumpers_tmp[i].tpoints>-1000)
		sprintf(&text_field[j][40],"%.1lf pts",(double)(jumpers_tmp[i].tpoints)/10.0);
	}
	show_text(numberofcomp,header,text_field,wait);
}



int getjumper(FILE * f, contestant * j){
	size_t len;
	size_t l;
	char *tmp=new char[255];
	j->name = NULL;
	j->cont = ai1;
	j->color = 10230;
	while (fgets(tmp, 255, f)){
		l=strlen(tmp);
		if (l == 0 || tmp[0] == '#' || tmp[0] == '\n') continue;
		if (strncmp("-----", tmp, strlen("-----"))==0){ 
			free(tmp); 
			break;
		}
		else if (strncmp("name", tmp, strlen("name"))==0) {
        		int i;
			char * c = strchr(tmp, '=');
			if (!c){ 
				message("competitors.txt : wrong option format: %s", tmp); 
				continue;
			}
			++c;
			while (isspace(*c)) ++c;
			i = strlen(c);
			while (i && isspace(c[i-1])) --i;
			if (!i){ 
				message("competitors.txt : empty name: %s",tmp); 
				continue;
			}
			j->name = new char[i+1];
			strncpy(j->name, c, i);
			j->name[i]='\0';
		} 
		else if (strncmp("control", tmp, strlen("control"))==0) {
			char * c = strchr(tmp, '=');
			if (!c){ 
				message("competitors.txt : wrong option format: %s", tmp); 
				continue;
			}
			++c;
			while (isspace(*c)) ++c;
			j->cont=unknown;
			for (int k=0;k<control_n;++k)
				if (!strncmp(short_c_names[k],c,strlen(short_c_names[k]))){
					j->cont=k;
				}
			if (j->cont==unknown)
				message("competitors.txt : wrong option format: %s",tmp);
		} 
		else if (strncmp("color", tmp, strlen("color"))==0) {
			char * c = strchr(tmp, '=');
			if (!c){ 
				message("wrong option format: %s", tmp); 
				continue;
			}
			++c;
			while (isspace(*c)) ++c;
			j->color=atoi(c);
		} else message("competitors.txt : unknown option: %s", tmp);
    }
    if (j->name == NULL) return -1;
    else return 0;
}

void load_competitors()
{
	FILE * f = fopen(CFGDIR"competitors.txt", "r");
	if (f == NULL) {
        	message("failed to open file: competitors.txt");
        	exit(1);
    	}
    jumpers = new contestant[255];
    numberofcomp=0;
    while (getjumper(f, &(jumpers[numberofcomp]))!=-1) ++numberofcomp;
    fclose(f);
}

int gethill(FILE * f, char ** name, enum system * st)
{
	size_t len;
	ssize_t l;
	char *tmp=new char[255];
    *name = NULL;
    *st = standard;
	while (fgets(tmp, 255, f)) {
		l=strlen(tmp);
		if (l == 0 || tmp[0] == '#' || tmp[0] == '\n') continue;
        if (strncmp("-----", tmp, strlen("-----"))==0) { free(tmp); break; }
        else if (strncmp("file", tmp, strlen("file"))==0) {
        	int i;
        	char * c = strchr(tmp, '=');
            if (!c) { fprintf(stderr, "wrong option format: %s", tmp); continue; }
            ++c;
            while (isspace(*c)) ++c;
            i = strlen(c);
            while (i && isspace(c[i-1])) --i;
            if (!i) { fprintf(stderr, "wrong name\n"); continue; }
            *name = new char[i+1];//malloc((i+1)*sizeof(char));
            strncpy(*name, c, i);
            (*name)[i]='\0';
        } else if (strncmp("system", tmp, strlen("system"))==0) {
        	char * c = strchr(tmp, '=');
            if (!c) { fprintf(stderr, "wrong option format: %s", tmp); continue; }
            ++c;
            while (isspace(*c)) ++c;
            if (strncmp("KO", c, strlen("KO"))==0) *st=KO;
            else if (strncmp("standard", c, strlen("standard"))==0) *st=standard;
            else fprintf(stderr, "unknown value: %s", c);
        } else fprintf(stderr, "unknown option: %s", tmp);
    }
    if (*name == NULL) return -1;
    else return 0;
}

void load_cup(char * fname)
{
	FILE * f;
	char fullpath[100];
	sprintf(fullpath,"%s%s",DATADIR,fname);
	f= fopen(fullpath, "r");
	if (f == NULL) {
	message("cannot load cup: %s",fname);
        exit(1);
    }
    hills = new char * [50];
    syst = new enum system[50];
    numberofhills=0;
	while (fgetc(f)!='\n');
    while (gethill(f, &hills[numberofhills], &syst[numberofhills])!=-1) ++numberofhills;
    fclose(f);
}

void jumpers_menu(){
	int i, choice, ncolor;
	bool deleted=false;
	menu_t jmenu=menu_t("%-20s%-20s%s","Name", "control", "color");
	load_competitors();
	for (i=0;i<numberofcomp;++i)
		jmenu.add_item("%-20s%-20s%d",jumpers[i].name, control_names[jumpers[i].cont], jumpers[i].color);
	jmenu.add_item("New jumper");
	jmenu.add_item("Back");
	while ((choice=jmenu.get_choice())!=numberofcomp+1) {
		if (choice==numberofcomp){
			jmenu.change_item(numberofcomp+1,"New Jumper");
			jmenu.add_item("Back");
			jumpers[numberofcomp].name=new char[5];
			strcpy(jumpers[numberofcomp].name,"");
			jumpers[numberofcomp].cont=0;
			jumpers[numberofcomp].color=rand()%1000;
			++numberofcomp;
		}
    		int jchoice, cchoice;
		char *tmp;
		menu_t smenu=menu_t("Jumper setup");
		smenu.add_item("Name: %s", jumpers[choice].name);
		smenu.add_item("Control: %s", control_names[jumpers[choice].cont]);
		smenu.add_item("Color: %d", jumpers[choice].color);
		smenu.add_item("Delete");
		smenu.add_item("Back");
		while ((jchoice=smenu.get_choice())!=4) {
			switch (jchoice) {
				case 0: {
					/*jumper's name*/
		                	tmp = getstring("Name", "");
                			if (isalnum(tmp[0])) {
						delete jumpers[choice].name;
						jumpers[choice].name = tmp;
						smenu.change_item(0,"Name: %s", jumpers[choice].name);
					}
					break;
					}
				case 1: /*control menu*/ {
					menu_t cmenu=menu_t("Choose control");
					for (int k=0;k<control_n;++k)
						cmenu.add_item(control_names[k]);
					cchoice=cmenu.get_choice();
					smenu.change_item(1,"Control: %s",control_names[cchoice]);
					jumpers[choice].cont=cchoice;
					break;
					}
				case 2:	ncolor=color_picker(jumpers[choice].color);
					jumpers[choice].color=ncolor;
					smenu.change_item(2,"Color: %d",jumpers[choice].color);
					break;
				case 3: {
					menu_t dmenu=menu_t("Delete this jumper?");
					dmenu.add_item("No");
					dmenu.add_item("Yes");
					if (dmenu.get_choice()==1){
						delete jumpers[choice].name;
						for (int k=choice;k<numberofcomp-1;++k)
							jumpers[k]=jumpers[k+1];
						--numberofcomp;
						jmenu.delete_item(choice);
						deleted=true;
					}
					break;
					}
            		}
			if (deleted) {deleted=false;break;}
			if (choice<numberofcomp)
        		jmenu.change_item(choice,"%-20s%-20s%d",
				jumpers[choice].name,
				control_names[jumpers[choice].cont],
				jumpers[choice].color);
        	}
//        destroy(jchoices, 4);
    }
//	destroy(choices, i);
    save_competitors();
}

void save_competitors()
{
	int i;
	FILE * f = fopen(CFGDIR"competitors.txt", "w");
	if (f == NULL) {
        	message("failed to open file: competitors.txt");
        	exit(1);
    }
    fprintf(f, "#rows begining wiht hash are comments\n\
#options are 'name' and 'control'\n\
#default value for control is 'ai'\n\
#option 'name' is required for each jumper\n\
#jumpers are separeted with '-----'\n\
#notice: there are 5 hyphens!!!\n");
    for (i=0;i<numberofcomp;++i) {
		fprintf(f, "name = %s\ncolor = %d\ncontrol = %s\n-----\n",
        	jumpers[i].name, jumpers[i].color, short_c_names[jumpers[i].cont]);
    }
    fclose(f);
}

