#include "allegro.h"
#include <math.h>
#include <stdio.h>
#include <string.h>

#include "draw.h"
#include "main.h"
#include "hill.h"
#include "jumper.h"
#include "api.h"


#ifdef ALLEGRO_UNSTABLE
#define ASPECT 1.33
#else
#define ASPECT 1
#endif

MATRIX_f camera;
int current_cam;
camera_t cam[10];
BITMAP *screen_bufor;
BITMAP *texture1;

void audience(double x, double l, double z, int c){
	int r=getr(c);
	int g=getg(c);
	int b=getb(c);
	const int h=400;
	const int w=500;
	const int d=100;
	q3d_later(	x,lagrange(x,hill),z,		//front face
			x,lagrange(x,hill),z-w,
			x,lagrange(x,hill)-h,z-w,
			x,lagrange(x,hill)-h,z-w+d,
			makecol(r,g,b));
	q3d_later(	x+l,lagrange(x+l,hill),z,	//side
		x+l,lagrange(x+l,hill)-h,z-w+d,
		x+l,lagrange(x+l,hill)-h,z-w,
		x+l,lagrange(x+l,hill),z-w,
		makecol(r-20,g-20,b-20));
	q3d_later(	x,lagrange(x,hill),z,		//top
			x,lagrange(x,hill)-h,z-w+d,

		x+l,lagrange(x+l,hill)-h,z-w+d,
		x+l,lagrange(x+l,hill),z,

			makecol(r+20,g+20,b+20));
	q3d_later(	x,lagrange(x,hill)-h,z-w+d,	//side
			x,lagrange(x,hill)-h,z-w,

		x+l,lagrange(x+l,hill)-h,z-w,
		x+l,lagrange(x+l,hill)-h,z-w+d,

			makecol(r-10,g-10,b-10));
	q3d_later(	x,lagrange(x,hill),z-w,		//back face
			x+l,lagrange(x+l,hill),z-w,
			x+l,lagrange(x+l,hill)-h,z-w,
			x,lagrange(x,hill)-h,z-w,
			darken(c,-30));

/*	for (i=15;i<l;i+=30)
		for (j=1;j<h-30;j+=30)
			circlefill(screen_bufor,
				(int)m3dx(x+i-offsetx,z-w/h*(h-j)),
				(int)m3dy(lagrange(x,hill)+(lagrange(x+l,hill)-lagrange(x,hill))/l*i-h+j-offsety,z-w/h*(h-j)),
				(int)m3dl(12,z-w/h*(h-j)),i*i*123/j+j*j*321/i);*/



		
	
}
int darken(int col, int val){
	return makecol(maxv(minv(getr(col)+val,255),0),maxv(minv(getg(col)+val,255),0),maxv(minv(getb(col)+val,255),0));
}
void q3d(	double x1, double y1, double z1,
		double x2, double y2, double z2,
		double x3, double y3, double z3,
		double x4, double y4, double z4, int color){
	V3D_f _p[4], _pout[50], _ptmp[50];
	V3D_f *p[4], *pout[50], *ptmp[50];
	int some_tmp[50];
	int i,n;
	for (i=0;i<4;++i)
		p[i]=&_p[i];
	for (i=0;i<8;++i){
		pout[i]=&_pout[i];
		ptmp[i]=&_ptmp[i];
	}
	p[0]->x=x1;
	p[0]->y=y1;
	p[0]->z=z1;
	p[1]->x=x2;
	p[1]->y=y2;
	p[1]->z=z2;
	p[2]->x=x3;
	p[2]->y=y3;
	p[2]->z=z3;
	p[3]->x=x4;
	p[3]->y=y4;
	p[3]->z=z4;
	for (i=0;i<4;++i)
		apply_matrix_f(&camera,p[i]->x,p[i]->y,p[i]->z,&p[i]->x,&p[i]->y,&p[i]->z);	
	n=clip3d_f(POLYTYPE_FLAT,0.1,fog_dist,4,(AL_CONST V3D_f **)p,pout,ptmp,some_tmp);
	if (n<=0) return;
	for (i=0;i<n;++i)
		persp_project_f(pout[i]->x, pout[i]->y, pout[i]->z, &pout[i]->x, &pout[i]->y);
	if (polygon_z_normal_f(pout[2], pout[1], pout[0]) < 0) return;
	pout[0]->c=color;
	polygon3d_f(screen_bufor,POLYTYPE_FLAT, NULL, n, pout);	
}
inline void q3d_later(	double x1, double y1, double z1,
		double x2, double y2, double z2,
		double x3, double y3, double z3,
		double x4, double y4, double z4, int color){
	V3D_f _p[4], _pout[50], _ptmp[50];
	V3D_f *p[4], *pout[50], *ptmp[50];
	int some_tmp[50];
	int i,n;
	for (i=0;i<4;++i)
		p[i]=&_p[i];
	for (i=0;i<8;++i){
		pout[i]=&_pout[i];
		ptmp[i]=&_ptmp[i];
	}
	p[0]->x=x1;
	p[0]->y=y1;
	p[0]->z=z1;
	p[0]->u=0;
	p[0]->v=0;
	p[1]->x=x2;
	p[1]->y=y2;
	p[1]->u=0;
	p[1]->v=32;
	p[1]->z=z2;
	p[2]->x=x3;
	p[2]->y=y3;
	p[2]->z=z3;
	p[2]->u=32;
	p[2]->v=32;
	p[3]->x=x4;
	p[3]->y=y4;
	p[3]->z=z4;
	p[3]->u=32;
	p[3]->v=0;
	for (i=0;i<4;++i)
		apply_matrix_f(&camera,p[i]->x,p[i]->y,p[i]->z,&p[i]->x,&p[i]->y,&p[i]->z);	
	n=clip3d_f(POLYTYPE_FLAT,0.1,fog_dist,4,(AL_CONST V3D_f **)p,pout,ptmp,some_tmp);
	if (n<=0) return;
	for (i=0;i<n;++i)
		persp_project_f(pout[i]->x, pout[i]->y, pout[i]->z, &pout[i]->x, &pout[i]->y);
	if (polygon_z_normal_f(pout[2], pout[1], pout[0]) < 0) return;
	pout[0]->c=color;
	if (scene_polygon3d_f(POLYTYPE_FLAT | POLYTYPE_ZBUF, NULL, n, pout)){
		message("scene_polygon3d_f: failed");
		exit(1);
	}
}

void draw_egg(double x1, double y1, double x2, double y2, double r, int tcolor){
        double R=sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
        double xp,yp;
        int p[8];
        xp=r*(y1-y2)/R/2;
	yp=r*(x2-x1)/R/2;
	p[0]=(int)(x1-xp);
	p[1]=(int)(y1-yp);
	p[2]=(int)(x1+xp);
	p[3]=(int)(y1+yp);
	p[4]=(int)(x2+xp);
	p[5]=(int)(y2+yp);
	p[6]=(int)(x2-xp);
	p[7]=(int)(y2-yp);
	polygon(screen_bufor,4,p,tcolor);
	circlefill(screen_bufor,(int)x1,(int)y1-1,(int)r*1/2,tcolor);
	circlefill(screen_bufor,(int)x2,(int)y2-1,(int)r*1/2,tcolor);
}
void quad(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int color){
	int points[8];
	points[0]=x1;
	points[1]=y1;
	points[2]=x2;
	points[3]=y2;
	points[4]=x3;
	points[5]=y3;
	points[6]=x4;
	points[7]=y4;
	polygon(screen_bufor,4,points,color);
}
void draw_cylinder(double x1, double y1, double z1, double x2, double y2, double z2, double r, int color){
	double angle=0;
	double a1,b1,c1,a2,b2,c2,a3,b3,c3,a4,b4,c4;
	double rot_h, rot_v, alfa, r1;
	double tmp1,tmp2,sin_rot_v,cos_rot_v;
	V3D_f _p[12], _q[12], _pout[200], _ptmp[200];
	V3D_f *p[12], *q[12], *pout[200], *ptmp[200];
	int some_tmp[200];
	int i,n;
	for (i=0;i<12;++i){
		p[i]=&_p[i];
		q[i]=&_q[i];
	}
	for (i=0;i<200;++i){
		pout[i]=&_pout[i];
		ptmp[i]=&_ptmp[i];
	}

	int d=0;
/*	q3d_later(x1-r,y1-r,z1-r,x1+r,y1+r,z1+r,x2+r,y2+r,z2+r,x2-r,y2-r,z2-r,color);
	q3d_later(x1-r,y1-r,z1-r,x2-r,y2-r,z2-r,x2+r,y2+r,z2+r,x1+r,y1+r,z1+r,color);*/
	if (x1>x2){
		a1=x1;
		x1=x2;
		x2=a1;
		a1=y1;
		y1=y2;
		y2=a1;
		a1=z1;
		z1=z2;
		z2=a1;
	}
	rot_h=atan2(z1-z2,x1-x2);
	rot_v=atan2(y1-y2,x1-x2);
	a1=x1;
	a2=x2;
	b1=y1+(tmp1=cos(angle))*r;
	b2=y2+tmp1*r;
	c1=z1+(tmp1=sin(angle))*r;
	c2=z2+tmp1*r;

//	message("a1 = %lf, b1 = %lf, c1 = %lf, a2 = %lf, b2 = %lf, c2 = %lf",a1,b1,c1,a2,b2,c2);
//	message("h %lf v %lf",rot_h,rot_v);
	a1+=(sin_rot_v=sin(rot_v))*(b1-y1);
	b1=(cos_rot_v=cos(rot_v))*(b1-y1)+y1;

	a2+=sin_rot_v*(b2-y2);
	b2=cos_rot_v*(b2-y2)+y2;

	alfa=atan2(c1-z1,a1-x1);
	r1=sqrt((x1-a1)*(x1-a1)+(z1-c1)*(z1-c1));
	a1=(tmp1=cos(alfa+rot_h))*r1+x1;
	c1=(tmp2=sin(alfa+rot_h))*r1+z1;

	a2=tmp1*r1+x2;
	c2=tmp2*r1+z2;
	
//	message("%lf",sqrt((a1-x1)*(a1-x1)+(b1-y1)*(b1-y1)+(c1-z1)*(c1-z1)));
	
	while (angle<M_PI*2-0.01){
		angle+=M_PI/6;
		p[d]->x=a1;
		p[d]->y=b1;
		p[d]->z=c1;
		q[d]->x=a2;
		q[d]->y=b2;
		q[d]->z=c2;
		d++;
		a3=x1;
		a4=x2;
		b3=y1+(tmp1=cos(angle))*r;
		b4=y2+tmp1*r;
		c3=z1+(tmp1=sin(angle))*r;
		c4=z2+tmp1*r;	
		
		a3+=sin_rot_v*(b3-y1);
		b3=cos_rot_v*(b3-y1)+y1;

		a4+=sin_rot_v*(b4-y2);
		b4=cos_rot_v*(b4-y2)+y2;

		alfa=atan2(c3-z1,a3-x1);
		r1=sqrt((x1-a3)*(x1-a3)+(z1-c3)*(z1-c3));
		a3=(tmp1=cos(alfa+rot_h))*r1+x1;
		c3=(tmp2=sin(alfa+rot_h))*r1+z1;

		a4=tmp1*r1+x2;
		c4=tmp2*r1+z2;

		q3d_later(a1,b1,c1,a3,b3,c3,a4,b4,c4,a2,b2,c2,darken(color,color ? 5*d : 0));
//		q3d_later(a1,b1,c1,a2,b2,c2,x2,y2,z2,x1,y1,z1,color+(int)(angle*100)+1000);

		
		a1=a3;
		b1=b3;
		c1=c3;

		a2=a4;
		b2=b4;
		c2=c4;

	}
//	message("%d",d);
	for (i=0;i<d;++i)
		apply_matrix_f(&camera,p[i]->x,p[i]->y,p[i]->z,&p[i]->x,&p[i]->y,&p[i]->z);	
	n=clip3d_f(POLYTYPE_FLAT,0.1,fog_dist,d,(AL_CONST V3D_f **)p,pout,ptmp,some_tmp);
	if (n>0) {
		for (i=0;i<n;++i)
			persp_project_f(pout[i]->x, pout[i]->y, pout[i]->z, &pout[i]->x, &pout[i]->y);
		if (polygon_z_normal_f(pout[0], pout[1], pout[2]) > 0) {
			pout[0]->c=color;
			if (scene_polygon3d_f(POLYTYPE_FLAT | POLYTYPE_ZBUF, NULL, n, pout)){
				message("scene_polygon3d_f: failed");
				exit(1);
			}
		}
	}
	for (i=0;i<d;++i)
		apply_matrix_f(&camera,q[i]->x,q[i]->y,q[i]->z,&q[i]->x,&q[i]->y,&q[i]->z);	
	n=clip3d_f(POLYTYPE_FLAT,0.1,fog_dist,d,(AL_CONST V3D_f **)q,pout,ptmp,some_tmp);
	if (n<=0) return;
	for (i=0;i<n;++i)
		persp_project_f(pout[i]->x, pout[i]->y, pout[i]->z, &pout[i]->x, &pout[i]->y);
	if (polygon_z_normal_f(pout[2], pout[1], pout[0]) < 0) return;
	pout[0]->c=color;
	if (scene_polygon3d_f(POLYTYPE_FLAT | POLYTYPE_ZBUF, NULL, n, pout)){
		message("scene_polygon3d_f: failed");
		exit(1);
	}

	
}
void background(BITMAP **bmp){
	float x=sin(-ccam.angle_h)*1000000,y=lowest_point_y,z=cos(-ccam.angle_h)*1000000;
	clear_to_color(*bmp,makecol(200,200,200));
	apply_matrix_f(&camera,x,y,z,&x,&y,&z);
	persp_project_f(x,y,z,&x,&y);
	if (y>=0)
		rectfill(*bmp,0,0,SCREEN_W,(int)y,makecol(150,150,255));
}
/*void set_camera(enum camera_t type, double x, double y, double z, double dx, double dy, double dz){
	switch (type){
		
		case FPP:
			get_camera_matrix_f(&camera,
				pzd-c_zoom*sin(-rot_cam_h)*cos(-rot_cam_v),pyd-offsety-c_zoom*sin(-rot_cam_v),\
				pxd-offsetx-c_zoom*cos(-rot_cam_v)*cos(-rot_cam_h),\
				sin(-rot_cam_h)*cos(-rot_cam_v),sin(-rot_cam_v),cos(-rot_cam_v)*cos(-rot_cam_h),\
				0,-1,0,48,1.33);
			break;
		case TPP:
			get_camera_matrix_f(&camera,A,B-offsety,C-offsetx,\
				-A+pzd,-B+pyd,-C+pxd,\
				0,-1,0,48,1.33)
#define SET_J_CAMERA \
	get_camera_matrix_f(&camera,pzd+cz[0],pyd+cy[0]-offsety-10,pxd+cx[0]-offsetx,\
		0,fabs(jumper_vy)*2+cx[0]-cx[10],jumper_vx-cy[0]+cy[10]+10,\
		0,-1,0,64,1.33)\

//	+cz[0]-cz[10],+cy[0]-cy[10],+cx[0]-cx[10],

}*/
void camera_t::place(double x, double y, double z, double a, double b, double c){
	switch (type){
	case TPP:
		offsetx=x;
		offsety=y;
		offsetz=z;
		angle_h=a;
		angle_v=b;
		dist=c;
		break;
	case FPP:
		offsetx=x;
		offsety=y;
		offsetz=z;
		angle_h=a;
		angle_v=b;
		dist=0;
		break;
	case STAND:
		offsetx=x;
		offsety=y;
		offsetz=z;
		sx=a;
		sy=b;
		sz=c;
		break;
	}
}
void camera_t::move(double x, double y, double z){
	offsetx=x;
	offsety=y;
	offsetz=z;
}
void camera_t::rotate(double h, double v, double d){
	if (type==STAND) return;
	angle_h+=h;
	if (angle_h>M_PI) angle_h-=2*M_PI; else
	if (angle_h<-M_PI) angle_h+=2*M_PI;
	angle_v+=v;
	if (angle_v>M_PI) angle_v-=2*M_PI; else
	if (angle_v<-M_PI) angle_v+=2*M_PI;
	dist+=d;
}
void camera_t::activate(){
	if (type==TPP)
		get_camera_matrix_f(&camera,
			sx=(offsetx-dist*sin(-angle_h)*cos(-angle_v)),sy=(offsety-dist*sin(-angle_v)),
			sz=(offsetz-dist*cos(-angle_v)*cos(-angle_h)),
			sin(-angle_h)*cos(-angle_v),sin(-angle_v),cos(-angle_v)*cos(-angle_h),
			0,-1,0,48,ASPECT);
	if (type==FPP)
		get_camera_matrix_f(&camera,
			sx=offsetx,sy=offsety,sz=offsetz,
			sin(angle_h)*cos(angle_v),sin(angle_v),cos(angle_v)*cos(angle_h),
			0,-1,0,48,ASPECT);
	if (type==STAND)
		get_camera_matrix_f(&camera,
			sx,sy,sz,
			offsetx-sx,offsety-sy,offsetz-sz,
			0,-1,0,48,ASPECT);


}
void read_cameras(){
	int i=0;
	char bufor[100];
	FILE *in=fopen(CFGDIR"cameras.txt","r");
	while (!feof(in)){
		fgets(bufor,99,in);
		cam[i].name=new char[strlen(bufor)+10];
		strcpy(cam[i].name,bufor);
//		message("name: %s",cam[i].name);
		fgets(bufor,99,in);
		switch(bufor[0]){
			case 'F':cam[i].type=FPP;break;
			case 'T':cam[i].type=TPP;break;
			case 'S':cam[i].type=STAND;break;
		}
//		message("type: %d",cam[i].type);
		if (cam[i].type==FPP){
			fscanf(in,"%lf%lf\n",&cam[i].angle_h,&cam[i].angle_v);
			cam[i].angle_h*=M_PI/180;
			cam[i].angle_v*=M_PI/180;
		}
		if (cam[i].type==TPP){
			fscanf(in,"%lf%lf%lf\n",&cam[i].angle_h,&cam[i].angle_v,&cam[i].dist);
			cam[i].angle_h*=M_PI/180;
			cam[i].angle_v*=M_PI/180;
//			message("pos: %lf %lf %lf",cam[i].angle_h,cam[i].angle_v,cam[i].dist);
		}
		if (cam[i].type==STAND){
			fscanf(in,"%lf%lf%lf\n",&cam[i].sx,&cam[i].sy,&cam[i].sz);
		}
		fscanf(in,"\n");
		++i;
	}
}
