#ifndef _DRAW_H
#define _DRAW_H 1
#include "allegro.h"
#define ZOOM 50.0
#define ccam cam[current_cam]

enum camera_types { TPP, FPP, STAND };


void audience(double, double, double, int);
void q3d(double, double, double, double, double, double, double, double, double, double, double, double, int);
void q3d_later(double, double, double, double, double, double, double, double, double, double, double, double, int);

void draw_egg(double, double, double, double, double, int);
void draw_cylinder(double, double, double, double, double, double, double, int);
void background(BITMAP **);
void set_camera(enum camera_types, double, double, double, double, double, double);
void read_cameras();
int darken(int, int);

class camera_t {
	public: 
		enum camera_types type;
		
		void place(double, double, double, double, double, double);	//x,y,z are coords of the target
		//type=STAND:x	 , y	 , z	 , x1	 , y1	 , z1  or	//x1,y1,z1 are coords of the camera
		//type=FOOPP:x	 , y	 , z	 , angle_h,angle_v,distance	//angle_h(v) rotates the camera around
										//the horizontal(vertical) axis
										//distance - self explaining

		void rotate(double, double, double);	//rotate or move the camera around the target
			//angle_h,angle_v,distance
		void move(double, double, double);	//new position of the target
			//x	, y	, z
		void activate();
		double angle_h;
		double angle_v;
		double dist;
		double offsetx,offsety,offsetz;
		double sx,sy,sz;			//only if type==STAND
		char *name;
	private:
		MATRIX_f this_camera;
};
extern camera_t cam[10];
extern int current_cam;

extern MATRIX_f camera;
extern BITMAP *screen_bufor;
extern BITMAP *texture1;
#endif
