#ifndef _HILL_H
#define _HILL_H 1
#define HILL_N hill[0][0]
#define INRUN_N inrun[0][0]
#define INRUN_W 55.0
#define INRUN_C makecol(100,100,130)
#define WIND_REC_H 30
#define WIND_REC_W 100
#define WIND_REC_Y 10
#define WIND_REC_X 10
#define FLATTEN 20
#define HILL_SIZE 5.0
#define MAX_POINTS 10
#define CACHE_SIZE 50000
#define H_TEXT_COLOR makecol(255,100,100)


double lagrange(double, int [][3]);
inline int hill_w(int);
void tree(int, int);
double find_k(double);
double find_lowest_point(void);
int slope(double);
void hill_back(void);
void hill_front(void);
void hill_bench(void);
void hill_left(int);
void hill_right(int);
void hill_floor(int);
void inrun_left(int);
void inrun_right(int);
void inrun_floor(int);
void hill_ceil(int);
void hill_small(int,int,int,int,int,int,int,int);
double distance(double);
void read_hill(char *);
void new_record(char *, double, char *);
double get_record(char *);
int maxv(int, int);
int minv(int, int);
void make_cache();
void show_records();
double hill_w(double);

/*template T min(T, T);
template T max(T, T);*/


extern double lowest_point_y;
extern int hill[MAX_POINTS][3];
extern int inrun[MAX_POINTS][3];
extern double hillrec_x;

extern double cache[CACHE_SIZE];
extern double in_cache[CACHE_SIZE];
extern char cache_ready;
extern int cache_count;

#endif
