#include "allegro.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#include <jumper.h>
#include <main.h>
#include <hill.h>
#include <replay.h>
#include <draw.h>
#include <api.h>
#define BODY_PART(A, B, C, D) \
	draw_cylinder(pxd+cx[A],pyd+cy[A],pzd+cz[A],pxd+cx[B],pyd+cy[B],pzd+cz[B],C,D);
#define BODY_SHADE(A, B, C, D) \
	draw_cylinder(pxd+cx[A], \
			lagrange(cx[A]+pxd,pxd<inrun[INRUN_N][0] ? inrun:hill), \
			pzd+cz[A], \
			pxd+cx[B], \
			lagrange(cx[B]+pxd,pxd<inrun[INRUN_N][0] ? inrun:hill), \
			pzd+cz[B], \
			C,D);

#define G 10.0			//gravity
#define KNEE_1 -3.2		//knee rotation low limit
#define KNEE_2 -0.8		//high limit
#define FOOT_1 -2.0		//foot rotation low limit
#define FOOT_2 -0.1		//high limit
#define LOW -0.5		//limit for jumper_pos_ok();
#define J_ANGLE_CH 5.0		//minimal change of pos_angle
#define SLANDING -M_PI/2	//minimal angle between head and skies for safe landing
#define WHEREAMI pxd<inrun[INRUN_N][0] ? inrun : hill        //aproaching or ground
//#define WHEREAMI_L pxd<inrun[inrun_l-1][0] ? inrun_l : hill_l  //

int px,py;			//position of jumper (I think it's not used anymore)
double alfa[P_NUM];		//angle of points
double r[P_NUM];			//distance from points to (0,0,0)
double knee_angle;		
char new_value=0;		//if set, animation angles will set to a new value rather than changed
double friction_air=0.0003;
double friction_snow=0.003;
char where_was;
jumper_t jumper;
void jumper_t::set(){
	int i;
	j_bonus=0;
	//scolor=0;
/*	cx[0]=-9;
	cy[0]=0;
	cx[1]=20;
	cy[1]=0;
	cx[2]=0;
	cy[2]=-5;
	cx[3]=-5;
	cy[3]=-5;
	cx[4]=-3;
	cy[4]=-15;*/
	cx[0]=-2;
	cy[0]=-15;
	cz[0]=0;
	cx[1]=-5;
	cy[1]=-5;
	cz[1]=0;
	cx[3]=cx[2]=0;
	cy[3]=cy[2]=-5;
	cz[2]=-SKI_SPACE;
	cz[3]=SKI_SPACE;
	cx[5]=cx[4]=0;
	cy[5]=cy[4]=0;
	cz[4]=-SKI_SPACE;
	cz[5]=SKI_SPACE;
	cx[7]=cx[6]=-9;
	cy[7]=cy[6]=0;
	cz[6]=-SKI_SPACE;
	cz[7]=SKI_SPACE;
	cx[9]=cx[8]=20;
	cy[9]=cy[8]=0;
	cz[8]=-SKI_SPACE;
	cz[9]=SKI_SPACE;
	cx[10]=cx[1]+(cx[0]-cx[1])*(7.5)/(cy[1]-cy[0]);
	cy[10]=cy[1]-7.5;
	cz[10]=0;
	cx[12]=cx[11]=cx[1]-1.0;
	cy[12]=cy[11]=cy[1];
	cz[11]=SKI_SPACE+1.0;
	cz[12]=-SKI_SPACE-1.0;
	cy[14]=cy[13]=cy[10]+1.0;
	cx[14]=cx[13]=cx[10];
	cz[14]=-SKI_SPACE;
	cz[13]=SKI_SPACE;
	for (i=0;i<P_NUM;++i){
		cx[i]*=JUMPER_SIZE;
		cy[i]*=JUMPER_SIZE;
		cz[i]*=JUMPER_SIZE;
	}
}
void jumper_t::ready(){
	pxd=1*ZOOM;
	pyd=lagrange(pxd,inrun);
	pzd=0;
        ef_wind=0;
        result=0;	
	vel=vel_x=vel_y=acc=acc_x=acc_y=0;
	friction_snow=0.003;
	block_keys=0;
	where_was=0;
	where_is=READY;
	flight_time=0;
}
/*void jumper_back_skis(){
	float x1_arg,y1_arg,x2_arg,y2_arg,z1_arg,z2_arg;
	jumper_rotate(pos_angle);
	jumper_rotate(-pos_angle);
}*/
void jumper_t::draw_main(){
	float x1_arg,y1_arg,x2_arg,y2_arg,z1_arg,z2_arg;
	rotate(pos_angle);
/*	if (!scolor){
		srand(time(0));
		scolor=rand()%1000+1;
	}*/
/*	rectfill(screen_bufor,(int)m3dx(cx[6]+pxd,cz[6]+pxd),
				(int)m3dy(*/
	BODY_PART(4,8,	ZOOM*SKI_T,60*scolor);
	BODY_PART(14,12,ZOOM*HAND_T,makecol(maxv(getr(scolor*20),20)-20,
				maxv(getg(scolor*20),20)-20,
				maxv(getb(scolor*20),20)-20));
	BODY_PART(1,2,	ZOOM*LEG_T,makecol(maxv(getr(50*scolor),20)-20,
				maxv(getg(scolor*50),20)-20,
				maxv(getb(scolor*50),20)-20));
	BODY_PART(2,4,	ZOOM*LEG_T,makecol(
				maxv(getr(50*scolor),20)-20,
				maxv(getg(scolor*50),20)-20,
				maxv(getb(scolor*50),20)-20));
	BODY_PART(0,10,	ZOOM*BELLY_T,30*scolor);
	BODY_PART(10,1,	ZOOM*BELLY_T,40*scolor);
	BODY_PART(1,3,	ZOOM*LEG_T,50*scolor);
	BODY_PART(3,5,	ZOOM*LEG_T,50*scolor);
	BODY_PART(13,11,ZOOM*HAND_T,20*scolor);
	BODY_PART(4,6,	ZOOM*SKI_T,60*scolor);
	BODY_PART(5,7,	ZOOM*SKI_T,60*scolor);

	x1_arg=cx[0]+pxd;
	y1_arg=cy[0]+pyd;
	z1_arg=cz[0]+pzd;
	
/*	get_camera_matrix_f(&camera,0,-SCREEN_H*cos(-rot_cam_v)*cos(-rot_cam_v),0,
			sin(-rot_cam_h)*cos(-rot_cam_v),sin(-rot_cam_v),cos(-rot_cam_v)*cos(-rot_cam_h),
			0,-1,0,48,1);*/
//	SET_CAMERA;
/*	apply_matrix_f(&camera,x1_arg,y1_arg,z1_arg,&x1_arg,&y1_arg,&z1_arg);
	persp_project_f(x1_arg,y1_arg,z1_arg,&x1_arg,&y1_arg);
	circlefill(screen_bufor,(int)x1_arg,(int)y1_arg,(int)ZOOM/10,scolor);*/

	BODY_PART(5,9,	ZOOM*SKI_T,60*scolor);

//	for (i=0;i<P_NUM;++i)
//		KROPKA(cx[i]+cz[i]/2,cy[i]+cz[i]/2,3,3,tcolor*2);
//	KROPKA(cx[0]+cz[0]/2,cy[0]+cz[0]/2,3,3,tcolor*2+1);	
	rotate(-pos_angle);
}
void jumper_t::draw_shadow(){
	int color;
	float x1_arg,y1_arg,x2_arg,y2_arg,z1_arg,z2_arg;
	color=5*2113+2113*(int)((lagrange(pxd,WHEREAMI)-pyd)/20);
	color=0;
	drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
	set_trans_blender(0,0,0,128);
	rotate(pos_angle);
	if (where_is==FLIGHT){
		BODY_SHADE(4,6,ZOOM/15,color);
		BODY_SHADE(4,8,ZOOM/15,color);
	}
	BODY_SHADE(0,10,ZOOM/15,color);
	BODY_SHADE(10,1,ZOOM/6,color);
	BODY_SHADE(1,2,ZOOM/10,color);
	BODY_SHADE(1,3,ZOOM/10,color);
	BODY_SHADE(2,4,ZOOM/10,color);
	BODY_SHADE(3,5,ZOOM/10,color);
	if (where_is==FLIGHT){
		BODY_SHADE(5,7,ZOOM/15,color);
		BODY_SHADE(5,9,ZOOM/15,color);
	}
	BODY_SHADE(10,11,ZOOM/15,color);
	BODY_SHADE(10,12,ZOOM/15,color);
	x1_arg=cx[0]+pxd;
	y1_arg=lagrange(cx[0]+pxd,WHEREAMI);
	z1_arg=cz[0]+pzd;
	
/*	get_camera_matrix_f(&camera,0,-SCREEN_H*cos(-rot_cam_v)*cos(-rot_cam_v),0,\
			sin(-rot_cam_h)*cos(-rot_cam_v),sin(-rot_cam_v),cos(-rot_cam_v)*cos(-rot_cam_h),\
			0,-1,0,48,1);\*/
//	SET_CAMERA;
/*	apply_matrix_f(&camera,x1_arg,y1_arg,z1_arg,&x1_arg,&y1_arg,&z1_arg);
	persp_project_f(x1_arg,y1_arg,z1_arg,&x1_arg,&y1_arg);
	circlefill(screen_bufor,(int)x1_arg,(int)y1_arg,(int)ZOOM/10,scolor);*/
	rotate(-pos_angle);
	drawing_mode(DRAW_MODE_SOLID,NULL,0,0);

}
void jumper_t::draw_small(double x, double y, double k){
	rotate(pos_angle);
	line(screen_bufor,(int)(x+cx[0]*k),(int)(y+cy[0]*k), (int)(x+cx[1]*k), (int)(y+cy[1]*k),0);
	line(screen_bufor,(int)(x+cx[1]*k),(int)(y+cy[1]*k), (int)(x+cx[2]*k), (int)(y+cy[2]*k),0);
	line(screen_bufor,(int)(x+cx[2]*k),(int)(y+cy[2]*k), (int)(x+cx[4]*k), (int)(y+cy[4]*k),0);
	line(screen_bufor,(int)(x+cx[4]*k),(int)(y+cy[4]*k), (int)(x+cx[8]*k), (int)(y+cy[8]*k),0);
	line(screen_bufor,(int)(x+cx[4]*k),(int)(y+cy[4]*k), (int)(x+cx[6]*k), (int)(y+cy[6]*k),0);
	rotate(-pos_angle);
}
void jumper_t::rotate(double beta){
	int i;
	double alfa,r;
	for (i=0;i<P_NUM;++i){
		alfa=atan2(cy[i],cx[i]);
		if (cy[i]==0 && cx[i]==0) alfa=0;
		r=sqrt(cx[i]*cx[i]+cy[i]*cy[i]);
		alfa-=beta;
		cy[i]=sin(alfa)*r;
		cx[i]=cos(alfa)*r;
	}
}
void jumper_t::anim(char what, double angle){
	double alfa,beta,r,r2;
	double ox,oy;
	int i,k;
	switch (what){
		case KNEE_UP:
			angle=-angle;
			alfa=atan2(cy[1]-cy[2],cx[2]-cx[1]);
			beta=alfa+atan2(cy[2]-cy[4],cx[2]-cx[4]);
			if ((beta>KNEE_2 && angle>0) || (beta<KNEE_1 && angle<0) || beta>0) break;
			r=sqrt((cx[1]-cx[2])*(cx[1]-cx[2])+(cy[1]-cy[2])*(cy[1]-cy[2]));
			ox=cx[1];
			oy=cy[1];
			if (!new_value)
			alfa+=angle; else alfa=angle;
			cy[1]=sin(alfa)*r+cy[2];
			cx[1]=-cos(alfa)*r+cx[2];
			cx[0]+=cx[1]-ox;
			cy[0]+=cy[1]-oy;
			for (i=10;i<=14;++i){
				cx[i]+=cx[1]-ox;
				cy[i]+=cy[1]-oy;
			}
			break;
		case HEAD_FRONT:
			alfa=atan2(cy[2],cx[2]);
			if (((alfa-atan2(cy[8],cx[8])<FOOT_1 && angle<0) || 
			     (alfa-atan2(cy[8],cx[8])>FOOT_2 && angle>0)) && !block_keys) break;
			for (i=0;i<P_NUM;++i)
				if (i<4 || i>9)	{
				alfa=atan2(cy[i],cx[i]);
				r=sqrt(cx[i]*cx[i]+cy[i]*cy[i]);

				if (!new_value)
				alfa+=angle; else alfa=angle;
				cy[i]=sin(alfa)*r;
				cx[i]=cos(alfa)*r;
			}
			
			break;
		case SKI_WIDER:
			if (!new_value){  
				if (angle<0 && cz[5]<=SKI_SPACE*JUMPER_SIZE) break; //this is not really angle, but distance
				cz[4]-=angle;
				cz[5]+=angle;
				cz[6]-=angle;
				cz[7]+=angle;
				cz[8]-=angle;
				cz[9]+=angle;
				r=sqrt((cx[5]-cx[3])*(cx[5]-cx[3])+(cy[5]-cy[3])*(cy[5]-cy[3]));
				r2=sqrt((cx[1]-cx[2])*(cx[1]-cx[2])+(cy[1]-cy[2])*(cy[1]-cy[2]));
				cz[2]-=angle*(r2)/(r2+r);
				cz[3]+=angle*(r2)/(r2+r);	
			} else {
				cz[4]=-angle;
				cz[5]=angle;
				cz[6]=-angle;
				cz[7]=angle;
				cz[8]=-angle;
				cz[9]=angle;
				r=sqrt((cx[5]-cx[3])*(cx[5]-cx[3])+(cy[5]-cy[3])*(cy[5]-cy[3]));
				r2=sqrt((cx[1]-cx[2])*(cx[1]-cx[2])+(cy[1]-cy[2])*(cy[1]-cy[2]));
				cz[2]=-angle*(r2)/(r2+r);
				cz[3]=angle*(r2)/(r2+r);	

			}
			break;
		case SKI_ANGLE:
			if (((where_is==FLIGHT && cz[9]<cz[7]) || ( where_is==GROUND && cz[9]<0.5 )) && angle<0) break;
			for (i=6;i<=9;++i){
				if (i==6 || i==8) k=4; else k=5;
				alfa=atan2(cz[i]-cz[k],cx[i]-cx[k]);
				r=sqrt((cz[i]-cz[k])*(cz[i]-cz[k])+(cx[i]-cx[k])*(cx[i]-cx[k]));
				if (!new_value){
					if (i==8 || i==6) 
						alfa-=angle; else
						alfa+=angle;
				} else {
					if (i==8) 
						alfa=-angle; else
					if (i==6) 
						alfa=-angle+M_PI; else
					if (i==9)
						alfa=angle; else
					if (i==7) alfa=angle-M_PI;

				}
				
				cz[i]=sin(alfa)*r+cz[k];
				cx[i]=cos(alfa)*r+cx[k];
			}
			break;
		case SKI_UP:
			alfa=atan2(cy[8],cx[8]);
			r=sqrt(cx[8]*cx[8]+cy[8]*cy[8]);
			if (!new_value)
				alfa+=angle; else
				alfa=angle;
			cy[8]=cy[9]=sin(alfa)*r;
			cx[8]=cx[9]=cos(alfa)*r;
			alfa=atan2(cy[6],cx[6]);
			r=sqrt(cx[6]*cx[6]+cy[6]*cy[6]);
			if (!new_value)
				alfa+=angle; else
				alfa=angle+M_PI;
			cy[6]=cy[7]=sin(alfa)*r;
			cx[6]=cx[7]=cos(alfa)*r;
			break;
		case HANDS_UP:
			break;
	}
}
double jumper_t::lift(){
	double alfa;
	double lift;
	alfa=atan2(-cy[0],cx[0]);
	lift=cos(alfa)*sin(alfa)*sqrt(cy[0]*cy[0]+cx[0]*cx[0])/ZOOM;
	alfa=atan2(cy[6]-cy[8],cx[8]-cx[6]);
	lift+=cos(alfa)*sin(alfa)*sqrt((cy[6]-cy[8])*(cy[6]-cy[8])+(cx[8]-cx[6])*(cx[8]-cx[6]))/ZOOM/2;
	return lift*400;
}
double jumper_t::frict(){
	double frict;
	double alfa;
	alfa=atan2(-cy[0],cx[0]);
	frict=sin(alfa)*sin(alfa)*sqrt(cy[0]*cy[0]+cx[0]*cx[0])/ZOOM;
	alfa=atan2(cy[6]-cy[8],cx[8]-cx[6]);
	frict+=sin(alfa)*sin(alfa)*sqrt((cy[6]-cy[8])*(cy[6]-cy[8])+(cx[8]-cx[6])*(cx[8]-cx[6]))/ZOOM/2;
	return frict*400;
}
void jumper_t::params(){
	textprintf(screen_bufor,font,SCREEN_W-300,5,0,"horizontal speed %f km/h",vel_x*3.6);
	textprintf(screen_bufor,font,SCREEN_W-300,15,0,"horizontal accel %f m/s^2",acc_x);
	textprintf(screen_bufor,font,SCREEN_W-300,25,0,"vertical speed %f km/h",vel_y*3.6);
	textprintf(screen_bufor,font,SCREEN_W-300,35,0,"vertical accel %f m/s^2",acc_y);
	textprintf(screen_bufor,font,SCREEN_W-300,45,0,"camera_h %f",ccam.angle_h/M_PI*180);
	textprintf(screen_bufor,font,SCREEN_W-300,55,0,"camera_v %f",ccam.angle_v/M_PI*180);
	textprintf(screen_bufor,font,SCREEN_W-300,65,0,"velocity %f km/h",sqrt(vel_x*vel_x+vel_y*vel_y)*3.6);
	textprintf(screen_bufor,font,SCREEN_W-300,75,0,"result %f m",result/(double)ZOOM);
	textprintf(screen_bufor,font,SCREEN_W-300,85,0,"flight time %d",flight_time*10/BFPS);
	textprintf(screen_bufor,font,SCREEN_W-300,95,0,"frames per second %d",frames);
	textprintf(screen_bufor,font,SCREEN_W-300,105,0,"wind %f",(double)wind/10);
	textprintf(screen_bufor,font,SCREEN_W-300,115,0,"jumper.pos_angle %f",pos_angle);
}
void rand_wind(){
	if (rand()%10==rand()%10) {
		wind+=1;
	}
	if (rand()%10==rand()%10) {
		wind-=1;
	}
	if (rand()%10==rand()%10) {
		side_wind+=1;
	}
	if (rand()%10==rand()%10) {
		side_wind-=1;
	}

}
void jumper_t::update_pos(){
	double alfa,beta;
	static int bend_knees=0; // the jumper bends his knees when he lands

	if (ef_wind*10<wind && where_is==FLIGHT){
		anim(SKI_UP,-0.001);
		ef_wind+=0.1;
	}
	if (ef_wind*10>wind && where_is==FLIGHT){
		anim(SKI_UP,0.001);
		ef_wind-=0.1;
	}
	switch (where_is){
		case FLIGHT:
			acc_x=-friction_air*frict()*(vel_x+(double)wind/10);
			vel_x+=acc_x/(double)BFPS;
			acc_y=G-friction_air*lift()*(vel_x+(double)wind/10);
			vel_y+=acc_y/(double)BFPS;
/*			if (pos_angle>J_ANGLE_CH/BFPS) pos_angle-=J_ANGLE_CH/BFPS/10.0;
			if (pos_angle<-J_ANGLE_CH/BFPS) pos_angle+=J_ANGLE_CH/BFPS/10.0;*/
			pxd+=(double)vel_x/BFPS*ZOOM;
			pyd+=(double)vel_y/BFPS*ZOOM;
			pzd+=(double)side_wind/BFPS*ZOOM/100;
//			jumper_draw(0);
			px=(int)(pxd);
			py=(int)(pyd);
//			jumper_draw(10000);
/*			while (px>hill[inrun_punkt+1][0])
				inrun_punkt++;*/
			if (pyd+cy[6]>lagrange(pxd+cx[6],hill))
				anim(SKI_UP,10.0/BFPS);
			if (pyd>lagrange(pxd,WHEREAMI)){
				landing_type=OK;
				if (atan2(cy[2],cx[2])-atan2(cy[8],cx[8])>SLANDING)
					landing_type=FALL_FRONT;
				result=distance(pxd);
				if (result>hill_rec*ZOOM && landing_type==OK && game_type==COMPETITION)
					new_record(hill_file,result/ZOOM,jumper.name);
				where_is=GROUND;
				alfa=atan2(lagrange(pxd+5.0,WHEREAMI)-lagrange(pxd,WHEREAMI),5.0);
				vel=sin(alfa)*vel_y+cos(alfa)*vel_x;
				new_value=1;
				anim(SKI_WIDER,2*JUMPER_SIZE);
//				jumper_anim(NART_KAT,-0.2);
				new_value=0;
			}
			break;

		case INRUN:
			alfa=-atan2(lagrange(pxd+5.0,inrun)-lagrange(pxd,inrun),5.0);
			if (pos_angle>alfa) pos_angle-=J_ANGLE_CH/BFPS;
			if (pos_angle<alfa) pos_angle+=J_ANGLE_CH/BFPS;
			if (fabs(pos_angle-alfa)<J_ANGLE_CH/BFPS)
				pos_angle=alfa;
			vel_angle=-alfa;
			acc=sin(vel_angle)*G-friction_snow*vel-
				friction_air*frict()*(vel_x+(double)wind/10)/2;
//			acc/=(double)(BFPS)/(ZOOM);
//			if (acc<0) acc=0;
			vel+=acc/(double)BFPS;
			pxd+=(vel_x=vel*cos(vel_angle))*(double)ZOOM/BFPS;
			vel_y=vel*sin(vel_angle);
			pyd=lagrange(pxd,inrun);
//			jumper_draw(0);
			px=(int)(pxd);
			py=(int)(pyd);
			if (frict()<40){
				where_is=GROUND;
				landing_type=FALL_FRONT;
//				friction_snow*=2000;
				result=0;
			}
//			jumper_draw(10000);
//			if (px>inrun[inrun_punkt+1][0]){
//				inrun_punkt++;
//				pyd=(double)s_wektor[inrun_punkt][1];
//			}
//			if (s_wektor[inrun_punkt][0]==s_wektor[inrun_punkt+1][0])
			if (pxd>inrun[INRUN_N][0]){
//				vga_getch();
				where_is=FLIGHT;
//				jknee=0;
//				jumper_anim(KNEE_UP,-3);
//				jumper_anim(HEAD_FRONT,0.5);
//				inrun_punkt++;
				vel_y=-j_bonus;
				bend_knees=0;
			}
			break;
		case GROUND:
			if (pos_angle>0.1) pos_angle-=0.1;else
			if (pos_angle<-0.1) pos_angle+=0.1;else
				pos_angle=0;
			alfa=-atan2(lagrange(pxd+5.0,WHEREAMI)-lagrange(pxd,WHEREAMI),5.0);
			beta=-atan2(cy[8],cx[8]);
			if (fabs(alfa-beta)>0.06){
				if (beta<alfa) anim(SKI_UP,-0.1); //pos_angle-=(double)SKOK_KAT/BFPS;
				if (beta>alfa) anim(SKI_UP,0.1); //pos_angle+=(double)SKOK_KAT/BFPS;
			}else {
				new_value=1;
				anim(SKI_UP,-alfa);
				new_value=0;
			}
/*			if (fabs(pos_angle-alfa)<SKOK_KAT/(double)BFPS)
				pos_angle=alfa;*/
			vel_angle=-alfa;
/*			alfa=atan2(cy[0],cx[0])-pos_angle;
			if (fabs(alfa+M_PI/2)>0.1) {
				if (alfa>-M_PI/2) jumper_anim(HEAD_FRONT,-0.1);
				if (alfa<-M_PI/2) jumper_anim(HEAD_FRONT,0.1);
			}*/
			acc=sin(vel_angle)*G-friction_snow*vel-
				friction_snow*3-
				friction_air*frict()*(vel+(double)wind/10);
//			acc/=(double)(BFPS);
//			if (acc<0) acc=0;
			vel+=acc/(double)BFPS;
			if (vel<0) vel=0;
			if (pxd<inrun[INRUN_N][0]) where_was=INRUN; else where_was=GROUND;
			pxd+=(vel_x=vel*cos(vel_angle))/(double)BFPS*ZOOM;
			if (where_was==INRUN && pxd>inrun[INRUN_N][0]){
				where_is=FLIGHT;
				break;
			}
			vel_y=vel*sin(vel_angle);
//			pyd+=(vel_y=vel*sin(vel_angle))/(double)BFPS;
			pyd=lagrange(pxd,WHEREAMI);
			px=(int)(pxd);
			py=(int)(pyd);
/*			if (pyd>lagrange(pxd,WHEREAMI,WHEREAMI_L)+5)
				where_is=FLIGHT;*/
			if (pyd+cy[1]>lagrange(pxd+cx[1],WHEREAMI)) 
				anim(HEAD_FRONT,0.01);
			if (bend_knees<20){
				anim(KNEE_UP,-(20.0-bend_knees)*0.3/BFPS);
				bend_knees++;
			}
/*			if (bend_knees<40 && bend_knees>=20){
				anim(KNEE_UP,3.0/BFPS);
				bend_knees++;
			}*/
			if (pxd>hill[HILL_N-1][0]-2000 && landing_type==OK){
				if (!block_keys) friction_snow*=100;
				if (cz[8]<0.0)
					anim(SKI_ANGLE,-0.5/BFPS);
				if (cz[5]<2.5*JUMPER_SIZE)
					anim(SKI_WIDER,2.5/BFPS*JUMPER_SIZE);
				if (cx[0]>5.0)
					anim(HEAD_FRONT,-2.5/BFPS); else
				if (cx[0]<-5.0)
					anim(HEAD_FRONT,2.5/BFPS);		
				alfa=atan2(cy[1]-cy[2],cx[2]-cx[1])+atan2(cy[2]-cy[4],cx[2]-cx[4]);
				if (alfa> (KNEE_2+4*KNEE_1)/5+0.05) anim(KNEE_UP,2.5/BFPS);
				if (alfa< (KNEE_2+4*KNEE_1)/5) anim(KNEE_UP,-2.5/BFPS);
				block_keys=1;
				
			}
//			landing_type=FALL_FRONT;
			if (landing_type==FALL_FRONT){
				if (!block_keys) friction_snow*=150;
				if (cy[0]+pyd<lagrange(cx[0]+pxd,WHEREAMI))
					anim(HEAD_FRONT,4.0/BFPS);
				if (cy[0]+pyd>lagrange(cx[0]+pxd,WHEREAMI)+5)
					anim(HEAD_FRONT,-1.5/BFPS);
				if (cz[5]<5.0*JUMPER_SIZE)
					anim(SKI_WIDER,2.5/BFPS*JUMPER_SIZE);
				if (cz[9]<8.0*JUMPER_SIZE)
					anim(SKI_ANGLE,0.5/BFPS);
				anim(KNEE_UP,5.0/BFPS);
				block_keys=1;
			}
			break;
	
	}
}
void jumper_t::takeoff(){
	where_is=FLIGHT;
	vel_y-=j_bonus;
}
char jumper_t::check_pos(){
	return atan2(cy[2],cx[2])-atan2(cy[8],cx[8])>LOW && atan2(cy[2],cx[2])-atan2(cy[8],cx[8])<=FOOT_2;
}

