#ifndef _JUMPER_H
#define _JUMPER_H 1

enum stages { READY, INRUN, FLIGHT, GROUND};
enum animations { KNEE_UP, KNEE_DOWN, HEAD_FRONT, HEAD_BACK, SKI_WIDER, SKI_ANGLE, SKI_UP, HANDS_UP};
enum landings { FALL_FRONT, FALL_BACK, OK};

#define LEG_T	0.15
#define HAND_T	0.1
#define HEAD_T	0.15
#define BELLY_T	0.15
#define SKI_T	0.1
#define NECK_T	0.1

#define KNEE_CH_ANGLE 0.005   	//by how much the knee angle chagnes
#define FOOT_CH_ANGLE 0.01	//same with foot angle
#define F_TAKEOFF 20.0		//the force of takeoff
#define JUMPER_SIZE 5.0
#define SKI_SPACE 1		//distance between skis (has to be multiplied by ZOOM)
#define P_NUM 15		//number of points the jumper consists of

void rand_wind();		//decreases or increases the wind


class jumper_t{
	public:
		void set();		//sets the shape, colors etc
		void ready();			//puts him at start
		void draw_main();			//rotates by jumper_angle, draws, and rotates back
		void draw_shadow();		//the same, but draws the shadow
		void draw_small(double, double, double);
		//void draw_back_skis();	//no comment on that one
		void rotate(double);		//rotation of the whole jumper
		void anim(char, double);	//all animations; first param is one of animations
		void update_pos(); 		//updates position == moves
		void takeoff();			//changes the vertical velocity
		char check_pos();		//verifies that the jumper position isn't too low or too high
		void params();
		
		double lift();			//a r d n m c
		double frict();			// e o y a i s

		double pos_angle;		
		enum stages where_is;		
		double j_bonus;			//power of the takeoff
		bool block_keys;			//blocks the arrow keys
		enum landings landing_type;		//one of landings
		int scolor;			//color of the jumper
		double cx[P_NUM],cy[P_NUM],cz[P_NUM];	//coordinates of points
		double vel;		//velocity of jumper
		double vel_x;		//x-part of velocity
		double acc,acc_y,acc_x; //accelerations
		double vel_y;		//y-part of velocity
		double vel_angle;		//angle of velocity
		double pxd, pzd, pyd;
		char *name;		// displayed somewhere during the jump
};

extern jumper_t jumper;

#endif
