#include "allegro.h"
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <time.h>
#include <math.h>

#include <main.h>
#include <jumper.h>
#include <hill.h>
#include <replay.h>
#include <api.h>
#include <cup.h>
#include <draw.h>
#include <ai.h>

int k_point;
int frames;
double result;
int flight_time;
double camerax,cameray,cameraz;
char hill_name[100];
int k_dist;
signed char wind, side_wind;
double ef_wind;
double lowest_point;
volatile int iterations;
char *hill_file;
double hill_rec;
double fog_dist;
game_types game_type;


void const_time(){
	++iterations;
}
END_OF_FUNCTION(const_time);
void change_options();
void menu(){
	int i=0;
	char *file[255];
	FILE *hills=fopen(CFGDIR"hills.txt","r");
	FILE *hillfile;
//	FILE *hillrec_f;
	char *hillname[255];
	char *jump_choice[50];
	int hills_n;
	int kp[255];
	char *choices[255];
	char *tmp[255];
	char fullpath[255];
	char up=0;
	int choice;
	menu_t mmenu=menu_t("Open Ski Jumping v"VERSION);
	menu_t hmenu=menu_t("Choose hill");
//	double hill_recs[100];
	for (i=0;i<50;++i){
		file[i]=new char[255];
		hillname[i]=new char[255];
		jump_choice[i]=new char[255];
		tmp[i]=new char[255];
	}
	i=0;
//	message("%d",sizeof(union u_f));
	if (!hills) {
/*		allegro_message("error: file not found: hills.txt\n");
		textprintf(screen,font,5,5,-1,"error: file not found: hills.txt");
		readkey();*/
		message("error: file not found: hills.txt");
		exit(1);
	}
	while (fscanf(hills,"%s",file[i])!=EOF){
		sprintf(fullpath,"%s%s",DATADIR,file[i]);
		hillfile=fopen(fullpath,"r");
		if (!hillfile){
			message("error: file not found: %s",file[i]);
			exit(1);
		}
		fscanf(hillfile,"%s%d",hillname[i],&kp[i]);
		fclose(hillfile);
		++i;
	}
	hills_n=i;
	for (i=0;i<hills_n;++i)
//		sprintf(jump_choice[i],"%-25s K%d",hillname[i],kp[i]);
		hmenu.add_item("%-25s K%d",hillname[i],kp[i]);
	hmenu.add_item("Back");
   	for (i=0;i<7;++i)
		choices[i]=new char[255];
	mmenu.add_item("Competition");
	mmenu.add_item("Practice");
	mmenu.add_item("Hill records");
	mmenu.add_item("Replays");
	mmenu.add_item("Options");
	mmenu.add_item("Credits");
	mmenu.add_item("Quit");
	while (1){
		choice=mmenu.get_choice();
		switch (choice) {
			case 0:
				cup_menu();
				break;
			case 1:
				while (1){
					choice=hmenu.get_choice();
					if (choice==hills_n) break;

/*					rot_cam_v=-M_PI/4;
					rot_cam_h=M_PI/4;
					c_zoom=SCREEN_H*2;*/

					do {
//						hill_file=file[choice];
						jumper.scolor=rand()%1000;
						game_type=PRACTICE;
						make_a_jump(file[choice]);
					} while (key[KEY_SPACE]);
				}
				break;
			case 2: show_records();
				break;
			case 3:
				get_replays_n();
				break;
			case 4: change_options();
				break;
			case 5:	strcpy(tmp[0],"Michal Brzozowski <rusolis@poczta.fm>  - coding");
				strcpy(tmp[1],"Adam Slaski <adam@interecho.com>       - coding");
				strcpy(tmp[2],"Bartosz Fenski <fenio@o2.pl>           - homepage");
				show_credits(3,"Credits",tmp);

				break;
			case 6: up=1;
				break;
		}
		if (up) break;
	}
	fclose(hills);
}
int op[10];
int option(enum options x){
	return op[x];
}
void change_options(){
	int choice=-1;
	menu_t option_m=menu_t("Change options");
	for (int i=0;i<1;++i)
		option_m.add_item("%d",i);
	option_m.add_item("back");

	do {
		if (choice>=0)
			op[choice]=-op[choice]+1;
//		option_m.change_item(0,"%-30s%s","audience",op[O_AUDIENCE]==0 ? "off" : "on");
//		option_m.change_item(1,"%-30s%s","camera zooming before jumps",op[O_C_ZOOM]==0 ? "off":"on");
		option_m.change_item(0,"%-30s%s","show AI jumps",op[O_SHOW_AI]==0?"off":"on");
	
	}while ((choice=option_m.get_choice())!=1);
}
void get_notes(int *t){
	for (int i=0;i<5;++i){
		t[i]=rand()%4+35+((int)(result/ZOOM)-k_dist)/10;
		if (jumper.landing_type!=OK)
			t[i]-=15;
		if (t[i]>40) t[i]=40;
		if (t[i]<0) t[i]=0;
		if (result/ZOOM<10.0) t[i]=0;
	}
}
double factor(int k){
	if (k>=180) return 12;
	if (k>=110) return 18;
	return 20;
}
int make_a_jump(char *hill_f){
	double takeoff_s=0;
	char blok=0;
	int freeze;
	int cframes,sframes;
	struct frame current_f;
	int disp_cam_name=0;
	int notes[5]={0};
	int result_p=0;
	int zooming_cam=9; //only at the beginning.  don't move it if the user moves it!!!
	int pdelay[5]={rand()%300, rand()%300, rand()%300, rand()%300, rand()%300}; //delay showing the notes
	BITMAP *ref[5]={0};
	ZBUFFER *zbuf1=create_zbuffer(screen_bufor);
	for (int i=0;i<5;++i){
		char buf[255];
		sprintf(buf,"%sref%d.pcx",DATADIR,i+1);
	//	message("loading %s",buf);
		ref[i]=load_bitmap(buf,NULL);
		if (!ref[i]){
			message("file not found: %s",buf);
			exit(1);
		}
	}
	hill_file=hill_f;
	set_zbuffer(zbuf1);
	wind=rand()%60-30;
	side_wind=rand()%60-30;
//	wind=0.0;
	read_hill(hill_f);
	jumper.set();
	jumper.ready();
	start_rec();
	sframes=cframes=frames=0;
//	jumper_draw(10000);
//	for (i=0;i<10000;++i){
	clear_to_color(screen_bufor,30000);
	jumper.pos_angle=-atan2(lagrange(5.0,inrun)-lagrange(0,inrun),5.0);
//	while (!key[KEY_RIGHT] && !key[KEY_ESC] && !key[KEY_SPACE]);
	iterations=0;
	cam[5].sx=inrun[INRUN_N][0];
	cam[5].sy=inrun[INRUN_N][1]-50;
	cam[5].sz=-300;
	fog_dist=5000;
	if (create_scene(1000,250)) {
		message("create scene: failed");
		exit(1);
	}
	current_cam=1;
	ccam.angle_h=M_PI/4+M_PI/2;
	ccam.offsetx=inrun[INRUN_N][0];
	ccam.offsety=inrun[INRUN_N][1];
	ccam.offsetz=0;
	ccam.angle_v=-M_PI/8;
	ccam.dist=10500;
	fog_dist=14000;
//	make_cache();
	while (!key[KEY_ESC] && (!key[KEY_SPACE] || !jumper.block_keys)){
		while (iterations && !key[KEY_ESC]){

			clear_frame(&current_f);
			++cframes;
			++disp_cam_name;

			if (cframes==BFPS){			//Measuring FPS
				frames=sframes;
				cframes=sframes=0;
			}


			--iterations;
			if (jumper.where_is==FLIGHT)
				++flight_time;
/*			if (flight_time<10){
				freeze=iterations;
				message("%f",(double)wind/10);
				iterations=freeze;
			}*/
			if (!jumper.block_keys){

				if (key[KEY_RIGHT]){
					current_f.key_right=1;
					if (jumper.where_is==READY) jumper.where_is=INRUN;
					jumper.anim(HEAD_FRONT,CHANGE/BFPS);
					if (jumper.where_is==FLIGHT && jumper.check_pos())
						jumper.anim(SKI_UP,-CHANGE/BFPS/5);
					if (jumper.where_is==FLIGHT && jumper.check_pos()){
						jumper.anim(SKI_WIDER,CHANGE/BFPS*20.0);
						jumper.anim(SKI_ANGLE,CHANGE/BFPS);
					}


				}
				if (key[KEY_LEFT]) {
					current_f.key_left=1;
					jumper.anim(HEAD_FRONT,-CHANGE/BFPS);
					if (jumper.where_is==FLIGHT)
						jumper.anim(SKI_UP,CHANGE/BFPS/5);
					if (jumper.where_is==FLIGHT && jumper.check_pos()) {
						jumper.anim(SKI_WIDER,-CHANGE/BFPS*20.0);
						jumper.anim(SKI_ANGLE,-CHANGE/BFPS);
					}

				}
				if (key[KEY_UP] || takeoff_s>0) {
					current_f.key_up=1;
					jumper.anim(KNEE_UP,takeoff_s>BFPS/10.0 ? CHANGE/BFPS*2 : CHANGE*10.0/BFPS);
					if (takeoff_s<BFPS/10.0) {
						if (jumper.where_is<=INRUN)
							jumper.anim(HEAD_FRONT,-CHANGE/BFPS/0.5);
						jumper.j_bonus+=F_TAKEOFF/BFPS;
					} else {
						if (jumper.where_is<=INRUN)
						jumper.takeoff();
					}
					++takeoff_s;
				}
				if (key[KEY_DOWN]) {
					current_f.key_down=1;
					jumper.anim(KNEE_UP,-CHANGE/BFPS);
					if (jumper.where_is>INRUN)
						takeoff_s=-10000;
				}
			}
			if (key[KEY_P] && !blok){
				freeze=iterations;
				while ((!blok || !key[KEY_P]) && !key[KEY_ESC] && !key[KEY_SPACE]){
					if (!key[KEY_P]) blok=1;
				}
				blok=1;
				iterations=freeze;
			}
			if (!key[KEY_P])
				blok=0;
//#ifdef DEBUG
			if (key[KEY_Q])
				fog_dist-=10;
			if (key[KEY_W])
				fog_dist+=10;
//#endif
			if (key[KEY_S]){
				char *rn;
				freeze=iterations;
				while (key[KEY_S]);
				rn=getstring("Enter file name to which replay will be saved:",".rpl");
				save_replay(rn,hill_f);
				iterations=freeze;
			}
			if (key[KEY_R] && jumper.block_keys && result_p){
				freeze=iterations;
				load_replay(0);
				iterations=freeze;
				return result_p;
			}
			if (key[KEY_J]){
				ccam.rotate(-0.01,0,0);
			}
			if (key[KEY_L]){
				ccam.rotate(0.01,0,0);
			}
			if (key[KEY_I]){
				ccam.rotate(0,-0.01,0);
			}
			if (key[KEY_K]){
				ccam.rotate(0,0.01,0);
			}
			if (key[KEY_Z])
				ccam.rotate(0,0,10);
			if (key[KEY_X])
				ccam.rotate(0,0,-10);
			for (int i=KEY_F1;i<=KEY_F6;++i){
				if (key[i]) { 
					current_cam=i-KEY_F1;
					disp_cam_name=0;
				}
			}
			if (zooming_cam==0)
			jumper.update_pos();
			if (jumper.where_is>READY){
				if (zooming_cam>0){
					zooming_cam=9;
					if (cam[1].dist>500) cam[1].dist-=50; else --zooming_cam;
					if (cam[1].angle_h>-M_PI/4+0.02)
						cam[1].angle_h-=M_PI/200; else --zooming_cam;
					if (cam[1].angle_h<-M_PI/4-0.02)
						cam[1].angle_h+=M_PI/2; else --zooming_cam;
					if (cam[1].angle_v>-M_PI/4+0.02)
						cam[1].angle_v-=M_PI/1000; else --zooming_cam;
					if (cam[1].angle_v<-M_PI/4-0.02)
						cam[1].angle_v+=M_PI/1000; else --zooming_cam;

					if (cam[1].offsetx>jumper.pxd+25) cam[1].offsetx-=50; else --zooming_cam;
					if (cam[1].offsetx<jumper.pxd-25) cam[1].offsetx+=50; else --zooming_cam;
					if (cam[1].offsety>jumper.pyd+25) cam[1].offsety-=50; else --zooming_cam;
					if (cam[1].offsety<jumper.pyd-25) cam[1].offsety+=50; else --zooming_cam;
					if (cam[1].offsetx<jumper.pxd+100 && cam[1].offsetx>jumper.pxd-100)
						cam[1].offsetx=jumper.pxd;
					if (cam[1].offsety<jumper.pyd+100 && cam[1].offsety>jumper.pyd-100)
						cam[1].offsety=jumper.pyd;

				} else {
					fog_dist=5000;
					if (ccam.type==FPP)
					ccam.move(jumper.pxd+jumper.cx[0], jumper.pyd+jumper.cy[0]-10, jumper.pzd+jumper.cz[0]);
					else
					ccam.move(jumper.pxd, jumper.pyd, jumper.pzd);
				}
			}

			if (!jumper.block_keys){
				current_f.wind=wind;
				current_f.s_wind=side_wind;
				rand_wind();
				add_frame(current_f);
			}
			if (jumper.block_keys && notes[0]==0){
				int nmin=40,nmax=0, w1,w2;
				get_notes(notes);
				for (int i=0;i<5;++i){
					if (notes[i]>nmax) { nmax=notes[i]; w2=i;}
				}
				for (int i=0;i<5;++i){
					if (notes[i]<nmin && i!=w2) { nmin=notes[i]; w1=i;}
				}
				for (int i=0;i<5;++i)
					if (i!=w1 && i!=w2)
						result_p+=notes[i]*5;
				result_p+=(int)((((floor(result/ZOOM*2)/2)-(double)k_dist)*factor(k_dist))+600.0);
				if (k_dist>=180) result_p+=600;					
			}
			if (jumper.block_keys)
				for (int i=0;i<5;++i)
					if (pdelay[i]) --pdelay[i];


		}
		++sframes;
		jumper.rotate(jumper.pos_angle);
		ccam.activate();
		jumper.rotate(-jumper.pos_angle);
		blit(screen_bufor,screen,0,0,0,0,SCREEN_W,SCREEN_H);
		background(&screen_bufor);
		clear_scene(screen_bufor);
		clear_zbuffer(zbuf1,0.);
		hill_floor(50);
		render_scene();
		clear_scene(screen_bufor);
		clear_zbuffer(zbuf1,0.);		
		if (ccam.sx<inrun[INRUN_N][0]){
			hill_left(20);
			hill_right(20);
		}
		inrun_floor(20);
		if (ccam.angle_h>=-M_PI/2 && ccam.angle_h<=M_PI/2) {
			if (ccam.sx>=inrun[INRUN_N][0])
				hill_right(20);
			inrun_right(20);
		}else {
			if (ccam.sx>=inrun[INRUN_N][0])
				hill_left(20);
			inrun_left(20);
		}
		if (ccam.type!=FPP){
			jumper.draw_shadow();
			hill_bench();
			jumper.draw_main();
		}
		render_scene();
		if (ccam.angle_h>=-M_PI/2 && ccam.angle_h<=M_PI/2) { 
			if (ccam.sx>=inrun[INRUN_N][0])
				hill_left(20);
			inrun_left(20);
		}else {
			if (ccam.sx>=inrun[INRUN_N][0])
				hill_right(20);
			inrun_right(20);
		}
		hill_ceil(20);
//		jumper.draw_small(20+jumper.pxd*128/SCREEN_W,20+jumper.pyd*96/SCREEN_H,0.4);
		jumper.draw_small(20+128/3,20+96*1/3,0.3);

		hill_small(20,20,128,96,(int)jumper.pxd-SCREEN_W*1/3,(int)jumper.pxd+SCREEN_W*2/3,
					(int)jumper.pyd-SCREEN_H*1/3,(int)jumper.pyd+SCREEN_H*2/3);


#ifdef DEBUG
		jumper.params();
#endif
		if (disp_cam_name<300)
			textprintf_centre(screen_bufor,font,SCREEN_W/2,20,H_TEXT_COLOR,"%s",ccam.name);
		if (game_type==COMPETITION)
		if (notes[0]!=0){
			drawing_mode(DRAW_MODE_TRANS,NULL,0,0);
			set_trans_blender(0,0,0,128);
			rectfill(screen_bufor,SCREEN_W/2-120,SCREEN_H-50,SCREEN_W/2+300,SCREEN_H-25,makecol(60,60,100));
//			rectfill(screen_bufor,SCREEN_W/2+140,SCREEN_H-50,SCREEN_W/2+200,SCREEN_H-25,makecol(60,60,100));
//			rectfill(screen_bufor,SCREEN_W/2+210,SCREEN_H-50,SCREEN_W/2+300,SCREEN_H-25,makecol(60,60,100));
			rectfill(screen_bufor,10,SCREEN_H-50,SCREEN_W/2-130,SCREEN_H-25,makecol(60,60,100));
			drawing_mode(DRAW_MODE_SOLID,NULL,0,0);
			textprintf(screen_bufor,font,20,SCREEN_H-40,0,"%s",jumper.name);
			textprintf(screen_bufor,font,SCREEN_W/2+150,SCREEN_H-40,0,"%.1lf m",floor(result/ZOOM*2)/2);
			if (!pdelay[0] && !pdelay[1] && !pdelay[2] && !pdelay[3] && !pdelay[4])
			textprintf(screen_bufor,font,SCREEN_W/2+220,SCREEN_H-40,0,"%.1lf pts",floor((double)(result_p))/10);

			for (int i=0;i<5;++i)
				if (!pdelay[i]){
					blit(ref[i],screen_bufor,0,0,SCREEN_W/2+i*50-105,SCREEN_H-70,24,18);
					textprintf(screen_bufor,font,SCREEN_W/2+i*50-110,SCREEN_H-40,0,
							"%.1lf",(double)(notes[i]*0.5));
				}
		}
	}
	destroy_scene();
	destroy_zbuffer(zbuf1);
	return result_p;
}
int main(int argc, char *argv[]){
//	BITMAP *hill_tlo;
//	PALETTE pal;
//	alarm(5);
	flight_time=0;
	allegro_404_char=' ';
	srand(time(0));
	cache_ready=0;
	allegro_init();
	install_keyboard();
	install_timer();
	LOCK_VARIABLE(iterations);
	LOCK_FUNCTION(const_time);
	set_color_depth(16);
#ifndef ADAM_DEBUG
    if (set_gfx_mode(GFX_AUTODETECT,640,480,0,0)){
		allegro_message("error with allegro\n");
		exit(1);
	}
#else
    if (set_gfx_mode(GFX_XWINDOWS,640,480,0,0)){
		allegro_message("error with allegro\n");
		exit(1);
	}
#endif
	screen_bufor=create_bitmap(SCREEN_W,SCREEN_H);
	clear_bitmap(screen_bufor);
	text_mode(-1);
//	texture1=load_bitmap(DATADIR"texture1.pcx",NULL);
/*	hill_tlo=load_bitmap("background.pcx",pal);
	if (!hill_tlo){
		allegro_message("no background\n");
		exit(1);
	}*/
	install_int_ex(const_time,BPS_TO_TIMER(BFPS));
	set_projection_viewport(0,0,SCREEN_W,SCREEN_H);
	//message("data: %s cfg: %s replay: %s",DATADIR,CFGDIR,REPLAYDIR);
	read_cameras();
	menu();
/*	while (1){
		make_a_jump(argc==2 ? argv[1] : "sko1.in");
	}*/

	return 0;
}
END_OF_MAIN();

