#include "allegro.h"
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>

#include "replay.h"
#include "main.h"
#include "jumper.h"
#include "hill.h"
#include "math.h"
#include "api.h"
#include "draw.h"

u_f flight_rec[MAX_LENGTH];
int replay_time;


void start_rec(){
	replay_time=0;
	memset(flight_rec,0,MAX_LENGTH*sizeof(union u_f));
}
void add_frame(struct frame data){
	flight_rec[replay_time].bits=data;
	++replay_time;
}
int save_replay(char *filename, char *hillname){
	int i;
	FILE *out;
	char fullpath[100];
	sprintf(fullpath,"%s%s",REPLAYDIR,filename);
	out=fopen(fullpath,"w");
	if (!out){
		message("error: cannot create file: %s",filename);
		return -1;
	}
	fprintf(out,"%s\n%d\n%d\n",hillname,replay_time,jumper.scolor);
	for (i=0;i<replay_time;++i)
		fprintf(out,"%lld\n",flight_rec[i].num);
	fclose(out);
	return 0;
}
void clear_frame(struct frame *f){
	f->key_up=0;
	f->key_down=0;
	f->key_left=0;
	f->key_right=0;
	f->wind=0;
}

int load_replay(char *filename){
	double takeoff_s=0;
	int freeze;
	int cframes,sframes;
	FILE *in;
	char hill[100];
	char slower=1;
	char fullpath[100];
	int zooming_cam=9;
	int disp_cam_name=0;
	int frame_n=0;
	BITMAP *R;
	PALETTE Rp;
	ZBUFFER *zbuf1=create_zbuffer(screen_bufor);
	set_zbuffer(zbuf1);
	sprintf(fullpath,"%s%s",REPLAYDIR,filename);
	R=load_bitmap(DATADIR"r.pcx",Rp);
	if (filename){
		in=fopen(fullpath,"r");
		if (!in){
			message("error: cannot load file: %s",filename);
			return -1;
		}
		fscanf(in,"%s%d%d",hill,&replay_time,&jumper.scolor);
		for (int i=0;i<replay_time;++i)
			fscanf(in,"%lld",&flight_rec[i].num);
		fclose(in);
	}
	read_hill(filename==NULL ? hill_file : hill);
	jumper.set();
	fog_dist=5000;
	jumper.ready();	
	sframes=cframes=frames=0;
	iterations=0;
	jumper.pos_angle=-atan2(lagrange(5.0,inrun)-lagrange(0,inrun),5.0);
	cam[5].sx=inrun[INRUN_N][0];
	cam[5].sy=inrun[INRUN_N][1]-50;
	cam[5].sz=-300;
	fog_dist=5000;
	if (create_scene(1000,250)) {
		message("create scene: failed");
		exit(1);
	}
	current_cam=1;
	ccam.angle_h=M_PI/4+M_PI/2;
	ccam.offsetx=inrun[INRUN_N][0];
	ccam.offsety=inrun[INRUN_N][1];
	ccam.offsetz=0;
	ccam.angle_v=-M_PI/8;
	ccam.dist=10500;
	fog_dist=14000;													
	while (!key[KEY_ESC] && !key[KEY_SPACE]){
		while (iterations>0 && !key[KEY_ESC]){	
			++cframes;
			++disp_cam_name;
				
			if (cframes==BFPS){			//Measuring FPS
				frames=sframes;
				cframes=sframes=0;
			}
			if (frame_n<replay_time){
				wind=flight_rec[frame_n].bits.wind;
				side_wind=flight_rec[frame_n].bits.s_wind;
			}

			iterations-=slower;
			if (jumper.where_is==FLIGHT)
				++flight_time;
			if (!jumper.block_keys){
				if (flight_rec[frame_n].bits.key_right){
					if (jumper.where_is==READY) jumper.where_is=INRUN;
					jumper.anim(HEAD_FRONT,CHANGE/BFPS);
					if (jumper.where_is==FLIGHT && jumper.check_pos())
						jumper.anim(SKI_UP,-CHANGE/BFPS/5);
					if (jumper.where_is==FLIGHT && jumper.check_pos()){
						jumper.anim(SKI_WIDER,CHANGE/BFPS*20.0);
						jumper.anim(SKI_ANGLE,CHANGE/BFPS);
				}

				}
				if (flight_rec[frame_n].bits.key_left) {
					jumper.anim(HEAD_FRONT,-CHANGE/BFPS);
					if (jumper.where_is==FLIGHT)
						jumper.anim(SKI_UP,CHANGE/BFPS/5);
					if (jumper.where_is==FLIGHT && jumper.check_pos()) {
						jumper.anim(SKI_WIDER,-CHANGE/BFPS*20.0);
						jumper.anim(SKI_ANGLE,-CHANGE/BFPS);
				}

				}
				if (flight_rec[frame_n].bits.key_up || takeoff_s>0) {
					jumper.anim(KNEE_UP,takeoff_s>BFPS/10.0 ? CHANGE/BFPS*2 : CHANGE*10.0/BFPS);
					if (takeoff_s<BFPS/10.0) {
						if (jumper.where_is<=INRUN) 
							jumper.anim(HEAD_FRONT,-CHANGE/BFPS/0.5);
						jumper.j_bonus+=F_TAKEOFF/BFPS;
					} else {
						if (jumper.where_is<=INRUN)
						jumper.takeoff();
					}
					++takeoff_s;
				}
				if (flight_rec[frame_n].bits.key_down) {
					jumper.anim(KNEE_UP,-CHANGE/BFPS);
					if (jumper.where_is>INRUN)
						takeoff_s=-10000;
				}
			}
/*			if (key[KEY_P] && !blok){
				freeze=iterations;
				while ((!blok || !key[KEY_P]) && !key[KEY_ESC] && !key[KEY_SPACE]){
					if (!key[KEY_P]) blok=1;
				}
				blok=1;
				iterations=freeze;
			}
			if (!key[KEY_P])
				blok=0;
			if (key[KEY_Q])
				wind+=0.1;
			if (key[KEY_W])
				wind-=0.1; */
			if (key[KEY_S] && filename==NULL){
				char *rn;
				freeze=iterations;
				while (key[KEY_S]);
				rn=getstring("Enter file name to which replay will be saved:",".rpl");
				save_replay(rn,hill_file);
				iterations=freeze;
			}
			if (key[KEY_1]) slower=1;
			if (key[KEY_2]) slower=2;
			if (key[KEY_3]) slower=3;
			if (key[KEY_4]) slower=10;
                        if (key[KEY_J])
				ccam.rotate(-0.01,0,0);
			if (key[KEY_L])
				ccam.rotate(0.01,0,0);
			if (key[KEY_I])
				ccam.rotate(0,-0.01,0);
			if (key[KEY_K])
				ccam.rotate(0,0.01,0);
			if (key[KEY_Z])
				ccam.rotate(0,0,10);
			if (key[KEY_X])
				ccam.rotate(0,0,-10);
			for (int i=KEY_F1;i<=KEY_F6;++i){
				if (key[i]) {
					current_cam=i-KEY_F1;
					disp_cam_name=0;
				}
			}
			if (zooming_cam==0)
			jumper.update_pos();
			if (jumper.where_is>READY){
				if (zooming_cam>0){
					zooming_cam=9;
					if (cam[1].dist>500) cam[1].dist-=50; else --zooming_cam;
					if (cam[1].angle_h>-M_PI/4+0.02)
						cam[1].angle_h-=M_PI/200; else --zooming_cam;
					if (cam[1].angle_h<-M_PI/4-0.02)
						cam[1].angle_h+=M_PI/2; else --zooming_cam;
					if (cam[1].angle_v>-M_PI/4+0.02)
						cam[1].angle_v-=M_PI/1000; else --zooming_cam;
					if (cam[1].angle_v<-M_PI/4-0.02)
						cam[1].angle_v+=M_PI/1000; else --zooming_cam;
					if (cam[1].offsetx>jumper.pxd+25) cam[1].offsetx-=50; else --zooming_cam;
					if (cam[1].offsetx<jumper.pxd-25) cam[1].offsetx+=50; else --zooming_cam;
					if (cam[1].offsety>jumper.pyd+25) cam[1].offsety-=50; else --zooming_cam;
					if (cam[1].offsety<jumper.pyd-25) cam[1].offsety+=50; else --zooming_cam;
					if (cam[1].offsetx<jumper.pxd+100 && cam[1].offsetx>jumper.pxd-100)
						cam[1].offsetx=jumper.pxd;
					if (cam[1].offsety<jumper.pyd+100 && cam[1].offsety>jumper.pyd-100)
						cam[1].offsety=jumper.pyd;
				} else {
					fog_dist=5000;
					if (ccam.type==FPP)
					ccam.move(jumper.pxd+jumper.cx[0], jumper.pyd+jumper.cy[0]-10, jumper.pzd+jumper.cz[0]);                                        else
					ccam.move(jumper.pxd, jumper.pyd, jumper.pzd);
				}
				
			}						
																				
			++frame_n;
		}
		++sframes;
		jumper.rotate(jumper.pos_angle);
		ccam.activate();
		jumper.rotate(-jumper.pos_angle);
		blit(screen_bufor,screen,0,0,0,0,SCREEN_W,SCREEN_H);
		background(&screen_bufor);
		clear_scene(screen_bufor);
		clear_zbuffer(zbuf1,0.);
		hill_floor(50);
		render_scene();
		clear_scene(screen_bufor);
		clear_zbuffer(zbuf1,0.);
		if (ccam.sx<inrun[INRUN_N][0]){
			hill_left(20);
			hill_right(20);
		}
		inrun_floor(20);
		if (ccam.angle_h>=-M_PI/2 && ccam.angle_h<=M_PI/2) {
			if (ccam.sx>=inrun[INRUN_N][0])
				hill_right(20);
			inrun_right(20);
		}else {
			if (ccam.sx>=inrun[INRUN_N][0])
				hill_left(20);
			inrun_left(20);
		}
		if (ccam.type!=FPP){
			jumper.draw_shadow();
			hill_bench();
			jumper.draw_main();
		}
		render_scene();
		if (ccam.angle_h>=-M_PI/2 && ccam.angle_h<=M_PI/2) {
			if (ccam.sx>=inrun[INRUN_N][0])
				hill_left(20);
			inrun_left(20);
		}else {
			if (ccam.sx>=inrun[INRUN_N][0])
				hill_right(20);
			inrun_right(20);
		}
		if (frame_n%50<25)
			draw_sprite(screen_bufor,R,5,5);
		hill_ceil(20);
#ifdef DEBUG
		jumper.params();
#endif
		if (disp_cam_name<300)
			textprintf_centre(screen_bufor,font,SCREEN_W/2,20,H_TEXT_COLOR,"%s",ccam.name);
	}
	destroy_scene();
	destroy_zbuffer(zbuf1);
	return 0;
}
void get_replays(){
	struct dirent *dp;
	DIR *dfd;
	char *replays[50];
	int i, frame_n=0, choice;
	char filename[256];
	for (i=0;i<50;++i)
		replays[i]=new char[255];
	
	dfd=opendir(REPLAYDIR);
	if (!dfd){
		message("error: cannot open data dir: %s",REPLAYDIR);
		exit(1);
	}
	while ((dp=readdir(dfd))!=NULL){
		strcpy(filename,dp->d_name);
		i=strlen(filename);
		if (!strcmp(&filename[i-4],".rpl"))
			strcpy(replays[frame_n++],filename);
	}
	strcpy(replays[frame_n++],"back");
	while (1){
		choice=get_choice(frame_n,"Choose replay",replays);
		if (choice==frame_n-1) break;
		load_replay(replays[choice]);
	}
}
char *replays[50];
int file_n;
void add_file(const char *filename, int atrib, int param){
	strcpy(replays[file_n++],get_filename(filename));
//	return 0;
}
void get_replays_n(){
	int i, choice;
	file_n=0;
	for (i=0;i<50;++i)
		replays[i]=new char[255];
	for_each_file(REPLAYDIR"*.rpl",0,add_file,0);
	strcpy(replays[file_n++],"back");
	while (1){
		choice=get_choice(file_n,"Choose replay",replays);
		if (choice==file_n-1) break;
		load_replay(replays[choice]);
	}

	
}
